	SUBROUTINE EPITET(KEY)
*****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IKOV(NOPRMAX),NDIV(3),NBNDT0(NPANMAX),KTQ(4)
     &   ,KCUT(3,4,6),IPQ(0:50,0:50,0:50),KTT(4),KGG(4)
     &   ,IGQ(0:50,0:50,0:50),IG0IG1(KMAX,NOPRMAX)
     &   ,IGS(0:50,0:50,0:50),ISG(NOPRMAX,NOPRMAX)
     &   ,IK0IK1(KMAX,NOPRMAX),KSYMPN(NOPRMAX,KMAX)
     &   ,MSYMPN(NOPRMAX,KMAX),KT(4)
	DIMENSION PNT(3,KMAX),EARR(NDIMMAX,KMAX,NPANMAX),E(4),H(4)
     &   ,WEIGH(LIMZN,KMAX,NPANMAX),WEIGK(LIMZN,2,NPANMAX,4)
     &   ,WEIGD(LIMZN,KMAX,NPANMAX),QWGT(4,3),AT(4),AD(4)
     &   ,RBAS(3,3),GBAS(3,3),WEPI(NBNDMAX,NBNDMAX,KMAX,NOPRMAX)
     &   ,QB(3,3),RB(3,3),QPNT(3),EPICHI(NBNDMAX,NBNDMAX)
     &   ,PKT(3,4),PQT(3,4),VK(3),VQ(3),VEL(3)
	LOGICAL EXIST
	COMMON /LATTICE/RBAS,GBAS,QB,RB                         !!! from init
	COMMON /QMESH/  NQPNT,QPNT                              !!! from init
	COMMON /MESH/   NPNT,PNT                                !!! from ttrmsh
	COMMON /ENERGY/ EARR,WEIGH,WEIGD                        !!! from lmtbnd
	COMMON /EPIWGT/ WEPI,EPICHI                             !!! from epitet
	COMMON /FREQUN/ FREQU                                   !!! from init
	COMMON /INVERS/ INV,IKOV                                !!! from group
	COMMON /GROUPOUT/NGROUP                                 !!! from group
	COMMON /SUBGROUP/NSGQ,NGEQ,ISG,KSYMPN,MSYMPN,IGS        !!! from symmsh
	COMMON /SYMMESH/IG0IG1,IK0IK1                           !!! from symmsh
	COMMON /WMESH/  KCUT,IPQ,IGQ                            !!! from bzmesh
        COMMON /LATPAR/ PAR                                     !!! from init
	COMMON /EFERMI/ EF                                      !!! from ttrint1
	COMMON /KAPPAR/ NPAN                                    !!! from init
	COMMON /INTTR/  NDIV                                    !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                       !!! from init
	COMMON /WORD/   NVAL                                    !!! from block
	COMMON /UNIT/   IUN                                     !!! from init
	DATA PI/3.141592653589793D0/
C  INITIALLY SET WEIGHTS FOR GIVEN POINT TO ZERO
        DOS=0.D0
        TOS=0.D0
        VEL(1)=0.D0
        VEL(2)=0.D0
        VEL(3)=0.D0
	DO 60 ISGQ=1,NSGQ
	DO 50 IPNT=1,NPNT
	DO 30 IBND1=1,NBNDF(1)-NBNDE(1)+1
	DO 20 IBND =1,NBNDF(1)-NBNDE(1)+1
	WEPI(IBND,IBND1,IPNT,ISGQ)=0.D0
  20    CONTINUE
  30    CONTINUE
  50    CONTINUE
  60    CONTINUE
C  SET DIVISIONS ALONG X,Y,Z
	N1=NDIV(1)
	N2=NDIV(2)
	N3=NDIV(3)
C  DO OVER WHOLE BRILLOUIN ZONE REPRESENTED BY MICROCELLS AND 
C  INTEGRATE OVER THE TETRAHEDRA
	OT=1.D0/N1/N2/N3/6.D0
	VOLIBZ=1.D0
	DO 230 I3=0,N3-1                    !!! over cells along G3
	DO 220 I2=0,N2-1                    !!! over cells along G2
	DO 210 I1=0,N1-1                    !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRA INSIDE MICROCELL
	DO 200 ITTR=1,6                         !!! over tetrahedra
	DO 70 I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT, SHIFTED - BY KTT1
	J1=I1+KCUT(1,I,ITTR)
	J2=I2+KCUT(2,I,ITTR)
	J3=I3+KCUT(3,I,ITTR)
	KTT(I)=IPQ(J1,J2,J3)
	KGG(I)=IGS(J1,J2,J3)
	KTQ(I)=IK0IK1(KTT(I),IGQ(J1,J2,J3))
  70    CONTINUE
C  SET UP POINTS K AND K+Q DESCRIBING TETRAHEDRA
        DO 80 I=1,4
        J1=I1+KCUT(1,I,ITTR)
        J2=I2+KCUT(2,I,ITTR)
        J3=I3+KCUT(3,I,ITTR)
        PKT(1,I)=(J1*QB(1,1)+J2*QB(1,2)+J3*QB(1,3))*2.D0*PI/PAR
        PKT(2,I)=(J1*QB(2,1)+J2*QB(2,2)+J3*QB(2,3))*2.D0*PI/PAR
        PKT(3,I)=(J1*QB(3,1)+J2*QB(3,2)+J3*QB(3,3))*2.D0*PI/PAR
        PQT(1,I)=PKT(1,I)+QPNT(1)*2.D0*PI/PAR
        PQT(2,I)=PKT(2,I)+QPNT(2)*2.D0*PI/PAR
        PQT(3,I)=PKT(3,I)+QPNT(3)*2.D0*PI/PAR
   80   CONTINUE
C  CALCULATE CONTRIBUTIONS FOR THESE POINTS
	DO 160 IPAN=1,1
	IBNDC=0
	DO 150 IBND=NBNDE(1),NBNDF(1)         !!! over all bands
	IBNDC=IBNDC+1
	DO 95 I=1,4
	E(I)=EARR(IBND,KTT(I),IPAN)           !!! E(k,j)
  95    CONTINUE
        CALL GETVEL(E,PKT,VK)                  !!! dE(kj)/dk
        CALL INTEGR1(E,EF,OT,AT,AD,TS,DS)      !!! d.o.s.
        DOS=DOS+DS
        TOS=TOS+TS
        DO 100 IVEL=1,3                        !!! velocities
        VEL(IVEL)=VEL(IVEL)+DS*VK(IVEL)**2
 100    CONTINUE
	IBNDC1=0
	DO 140 IBND1=NBNDE(1),NBNDF(1)         !!! over all bands
	IBNDC1=IBNDC1+1
	DO 120 I=1,4
	H(I)=EARR(IBND1,KTQ(I),IPAN)+FREQU     !!! E(g*k+q,j')+omega
 120    CONTINUE
        CALL GETVEL(H,PQT,VQ)                  !!! dE(gk+qj')/dk
	IF(KEY.EQ.1.OR.KEY.EQ.3)CALL MDHEAD(E,H,EF,OT,QWGT(1,1)) ! Im(hi)
	IF(KEY.EQ.2)CALL MCHEAD(E,H,EF,OT,QWGT(1,1)) ! Re(hi)
	DO 130 I=1,4
	ISGQ=KGG(I)
	IPNT=KTT(I)
	IF(KEY.EQ.1.OR.KEY.EQ.2)VFACT=1.D0
	IF(KEY.EQ.3)VFACT=(VK(1)**2+VK(2)**2+VK(3)**2)+
     &  (VQ(1)**2+VQ(2)**2+VQ(3)**2)-
     &  2.D0*(VK(1)*VQ(1)+VK(2)*VQ(2)+VK(3)*VQ(3))
	WEPI(IBNDC,IBNDC1,IPNT,ISGQ)=
     &  WEPI(IBNDC,IBNDC1,IPNT,ISGQ)+QWGT(I,1)*VFACT
 130    CONTINUE
 140    CONTINUE                             !!! over all bands
 150    CONTINUE                             !!! over all bands
 160    CONTINUE                             !!! over panels
 170    CONTINUE
 200    CONTINUE                             !!! over tetrahedra
 210    CONTINUE                             !!! over cells along G1
 220    CONTINUE                             !!! over cells along G2
 230    CONTINUE                             !!! over cells along G3
C  NORMALIZATION
	DO 280 ISGQ=1,NSGQ
	DO 270 IPNT=1,NPNT
	DO 250 IBND1=1,NBNDF(1)-NBNDE(1)+1
	DO 240 IBND=1,NBNDF(1)-NBNDE(1)+1
	WEPI(IBND,IBND1,IPNT,ISGQ)=WEPI(IBND,IBND1,IPNT,ISGQ)/
     &  VOLIBZ*2.D0
 240    CONTINUE
 250    CONTINUE
 270    CONTINUE                            !!! over irreducible points
 280    CONTINUE                            !!! over star of the q-vector
        DOS=DOS/VOLIBZ*2.D0                 !!! total dos
        TOS=TOS/VOLIBZ*2.D0                 !!! total dos
        VEL(1)=VEL(1)/VOLIBZ*2.D0           !!! average square of velocities
        VEL(2)=VEL(2)/VOLIBZ*2.D0
        VEL(3)=VEL(3)/VOLIBZ*2.D0
	WRITE(IUN,1000)EF,TOS,DOS
        WRITE(IUN,1010)
        WRITE(IUN,1020)(VEL(I),I=1,3)
C  INTEGRATION
	DO 330 IBND1=1,NBNDF(1)-NBNDE(1)+1
	DO 320 IBND=1,NBNDF(1)-NBNDE(1)+1
	EPICHI(IBND,IBND1)=0.D0
	DO 310 ISGQ=1,NSGQ
	DO 300 IPNT=1,NPNT
	EPICHI(IBND,IBND1)=EPICHI(IBND,IBND1)+WEPI(IBND,IBND1,IPNT,ISGQ)
 300    CONTINUE                            !!! over irreducible points
 310    CONTINUE                            !!! over star of the q-vector
 320    CONTINUE
 330    CONTINUE
	RETURN
1000    FORMAT(1X,'EF,TOS,DOS==',3(1X,G14.7))
1010    FORMAT(1X,'Calculated average square of electron velocities:')
1020    FORMAT(1X,'<Vx^2>=',G14.7,' ; <Vy^2>=',G14.7,' ; <Vz^2>=',G14.7)
	END



        SUBROUTINE GETVEL(E0,Q0,V)
*************************************************
*  Calculates velocities inside the tetrahedron *
*************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION E0(4),Q0(3,4),V(3),Q(3,3),EV(3)
        DO 10 J=1,3
        EV(J)=E0(J)-E0(4)
        DO 10 I=1,3
   10   Q(J,I)=Q0(I,J)-Q0(I,4)
        CALL SIMQ(Q,EV,3,3,IFAIL)
        IF(IFAIL.NE.0)PRINT*,'<GETVEL>: SIMQ FAILS'
        DO 20 IV=1,3
   20   V(IV)=EV(IV)
        END

