	SUBROUTINE MCTTRINT1(V,VT,A)
*****************************************************************
*    The calculation of the integrals over tetrahedron          *
*                                                               *
*        /  3     R(k)                                          *
*    A=  \ d k   ------                                         *
*        /        V(k)                                          *
*       ttr                                                     *
*                                                               *
*    (For instance V(k)=E(k)-E(k+q)+omega in the linear         *
*                                             response theory.) *
*    where V(k) is given at the vertexes of tetrahedron,        *
*    R(k) is 1,kx,ky,kz (for the matrix elements evaluation)    *
*    The linear interpolation is supposed.                      *
*    Written by S.Yu.Savrasov (Lebedev Physical Institute)      *
*****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION V(4),D(4),A(4),ALN(4),ICON(6),LL(6),MM(6)
     &   ,T(2:4),KK(2),KP(5),NN2(2:4,6),NN3(2:4,3)
     &   ,NN4(2:4,5)
	DATA LL/1,1,1,2,2,3/,MM/2,3,4,3,4,4/,KP/4,3,2,0,1/
     &      ,NN2/4,3,2,3,4,2,3,2,4,4,4,2,4,2,4,2,4,4/
     &      ,NN3/2,3,3,3,2,3,3,3,2/
     &      ,NN4/3,3,2,3,2,3,2,3,3,3,3,3,3,3,3/
C   DEFINE CASE OF COINCIDING
	DO 20 I=1,4
	DO 10 J=I+1,4
	IF(ABS(V(I)-V(J)).LE.1.D-05)V(J)=V(I)
  10    CONTINUE
  20    CONTINUE
	ICASE=0
	K=0
	DO 40 I=1,4
	DO 30 J=I+1,4
	K=K+1
	ICON(K)=0
	IF(ABS(V(I)-V(J)).LE.1.D-05)ICON(K)=1
	ICASE=ICASE+ICON(K)
  30    CONTINUE
  40    CONTINUE
C
	IF(ICASE.EQ.0)THEN !! ALL ELEMENTS ARE DIFFERENT
	 D(1)=V(1)**2/((V(1)-V(2))*(V(1)-V(3))*(V(1)-V(4)))
	 D(2)=V(2)**2/((V(2)-V(1))*(V(2)-V(3))*(V(2)-V(4)))
	 D(3)=V(3)**2/((V(3)-V(1))*(V(3)-V(2))*(V(3)-V(4)))
	 D(4)=-D(1)-D(2)-D(3)
	 A(1)=0
	  DO 50 I=1,4
	  ALN(I)=0.0
	  IF(ABS(V(I)).GE.1.D-08)ALN(I)=LOG(ABS(V(I)))
	  A(1)=A(1)+3.D0*D(I)*ALN(I)
  50      CONTINUE
	 DO 70 J=2,4
	 A(J)=0
	  DO 60 I=1,4
	  IF(I.NE.J)THEN
	  A(J)=A(J)+V(I)*D(I)*(ALN(I)-ALN(J))/(V(I)-V(J))
	  ELSE
	  A(J)=A(J)+D(J)
	  ENDIF     
  60      CONTINUE
  70     CONTINUE
C
	ELSEIF(ICASE.EQ.1)THEN !! TWO ELEMENTS ARE EQUAL
	 DO 80 K=1,6
	 IF(ICON(K).EQ.1)K0=K
  80     CONTINUE
	 VV=V(LL(K0))          !! EQUAL ELEMENTS
	 VV1=V(LL(7-K0))
	 VV2=V(MM(7-K0))
	 ALNV=0.0
	 IF(ABS(VV).GE.1.D-08)ALNV=LOG(ABS(VV))
	 ALNV1=0.0
	 IF(ABS(VV1).GE.1.D-08)ALNV1=LOG(ABS(VV1))
	 ALNV2=0.0
	 IF(ABS(VV2).GE.1.D-08)ALNV2=LOG(ABS(VV2))
	 DD1=1.D0/((VV1-VV)*(VV1-VV)*(VV1-VV2))
	 DD2=1.D0/((VV2-VV)*(VV2-VV)*(VV2-VV1))
	 DD3=1.D0/((VV-VV1)*(VV-VV2))
	 A(1)=3.D0*VV1**2*DD1*(ALNV1-ALNV)+3.D0*VV2**2*DD2*(ALNV2-ALNV)+
     &   3.D0*VV*DD3
	 SS1=DD3/(VV-VV1)
	 SS2=DD3/(VV-VV2)
	 OO2=3.D0-VV/(VV-VV1)-2.D0*VV/(VV-VV2)
	 OO3=3.D0-VV/(VV-VV2)-2.D0*VV/(VV-VV1)
	 T(2)=VV**2*SS2*OO2*(ALNV-ALNV2)+VV1**3*DD1/(VV1-VV2)*
     &   (ALNV1-ALNV2)+VV**2*SS2+VV2**2*DD2
	 T(3)=VV**2*SS1*OO3*(ALNV-ALNV1)+VV2**3*DD2/(VV2-VV1)*
     &   (ALNV2-ALNV1)+VV**2*SS1+VV1**2*DD1
	 T(4)=VV1**3*DD1/(VV1-VV)*(ALNV1-ALNV)+VV2**3*DD2/(VV2-VV)*
     &   (ALNV2-ALNV)+2.5D0*VV*DD3-VV**2*(SS1+SS2)
	 DO 90 I=2,4
	 A(I)=T(NN2(I,K0))
  90     CONTINUE
C
	ELSEIF(ICASE.EQ.2)THEN  !! TWO PAIRS ARE EQUAL
	 K=0
	 DO 100 I=1,6
	 IF(ICON(I).EQ.1)THEN
	 K=K+1
	 KK(K)=I
	 ENDIF
 100     CONTINUE
	 VV=V(LL(KK(1)))
	 VV1=V(LL(KK(2)))
	 ALNV=0.0
	 ALNV1=0.0
	 IF(ABS(VV).GE.1.D-08)ALNV=LOG(ABS(VV))
	 IF(ABS(VV1).GE.1.D-08)ALNV1=LOG(ABS(VV1))
	 DD=1.D0/(VV-VV1)**2
	 DD2=DD*DD
	 A(1)=6.D0*VV*VV1*DD2*(VV-VV1)*(ALNV1-ALNV)+3.D0*(VV+VV1)*DD
	 T(2)=3.D0*VV*VV1**2*DD2*(ALNV-ALNV1)+2.5D0*VV*DD+(2.D0*VV**2+
     &   VV1**2)*DD2*(VV1-VV)
	 T(3)=3.D0*VV1*VV**2*DD2*(ALNV1-ALNV)+2.5D0*VV1*DD+(2.D0*VV1**2+
     &   VV**2)*DD2*(VV-VV1)
	 DO 110 I=2,4
	 A(I)=T(NN3(I,KK(1)))
 110     CONTINUE
C
	ELSEIF(ICASE.EQ.3)THEN   !! THREE ELEMENTS ARE EQUAL
	 K=0
	 DO 120 I=1,6
	 IF(ICON(I).EQ.1)THEN
	 K=K+I
	 K0=I
	 ENDIF
 120     CONTINUE
	 M0=(K-5)/2
	 VV=V(LL(K0))
	 VV1=V(KP(M0))
	 DD=1.D0/(VV1-VV)**2
	 DD1=DD/(VV1-VV)
	 DD2=DD*DD
	 ALNV=0.0
	 ALNV1=0.0
	 IF(ABS(VV).GE.1.D-08)ALNV=LOG(ABS(VV))
	 IF(ABS(VV1).GE.1.D-08)ALNV1=LOG(ABS(VV1))
	 A(1)=3*VV1**2*DD1*(ALNV1-ALNV)+DD1*(6.D0*VV*VV1-
     &   4.5D0*VV1**2-1.5D0*VV**2)
	 T(2)=3.D0*VV*VV1**2*DD2*(ALNV-ALNV1)+DD*2.5D0*VV+
     &   DD1*(2.D0*VV**2+VV1**2)
	 T(3)=VV1**3*DD2*(ALNV1-ALNV)+11.D0/(VV-VV1)/6.D0-2.5D0*VV*DD-
     &   VV**2*DD1
	 DO 130 I=2,4
	 A(I)=T(NN4(I,M0))
 130     CONTINUE
C
	ELSEIF(ICASE.EQ.6)THEN !! ALL ELEMENTS ARE EQUAL
	 A(1)=1.D0/V(1)
	 A(2)=0.25D0*A(1)
	 A(3)=A(2)
	 A(4)=A(3)
	ENDIF
C
	DO 140 J=1,4           !! NORMALIZATION
	A(J)=A(J)*VT
 140    CONTINUE
	END


	SUBROUTINE MCTTRINT2(VT,A)
************************************************************
*    The calculation of the integrals over tetrahedron     *
*                                                          *
*        /  3                                              *
*    A=  \ d k  R(k)                                       *
*        /                                                 *
*       ttr                                                *
*                                                          *
*    where R(k) are 1,kx,ky,kz (for the matrix elements    *
*    evaluation). The linear interpolation is supposed.    *     
*    Written by S.Yu.Savrasov (Lebedev Physical Institute) *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION A(4)
	A(1)=VT
	DO 10 I=2,4
	A(I)=VT*0.25D0
  10    CONTINUE
	END
