	SUBROUTINE TTRINT1(EF0,TOS,DOS,KEY)
***********************************************************
*  The calculation of the weight functions for integrati- *
*  on over IBZ by means of tetrahedron method.            *
*  Written by S.Savrasov (P.N.Lebedev Physical Institute) *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NHSORT(NSORTMAX),IS(NPAT),NDIV(3)
     &   ,ILST(NSORTMAX),ILSB(NSORTMAX),ILSW(NSORTMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,KCUT(3,4,6),IPQ(0:50,0:50,0:50),KTT(4)
     &   ,IGQ(0:50,0:50,0:50)
	DIMENSION EARR(NDIMMAX,KMAX,NPANMAX)
     &   ,E(4),WEIGH(NDIMMAX,KMAX,NPANMAX),WGT(KMAX)
     &   ,WEIGD(NDIMMAX,KMAX,NPANMAX),AT(4),AD(4)
     &   ,PNT(3,KMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSW,NATOM,NHSORT    !!! from init
	COMMON /MESH/   NPNT,PNT,WGT                            !!! from ttrmsh
        COMMON /WMESH/  KCUT,IPQ,IGQ                            !!! from bzmesh
	COMMON /ENERGY/ EARR,WEIGH,WEIGD                        !!! from lmtbnd
	COMMON /KAPPAR/ NPAN                                    !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                       !!! from init
	COMMON /INTTR/  NDIV                                    !!! from init
	COMMON /UNIT/   IUN                                     !!! from init
	DATA PI/3.141592653589793D0/
C *********** INITIALIZATION **************
	EF=EF0
	TOS=0.D0
	DOS=0.D0
	TOT=0.D0
	DOT=0.D0
	VOLIBZ=1.D0
	OT=1.D0/NDIV(1)/NDIV(2)/NDIV(3)/6.D0
C *********** TETRAHEDRON METHOD **********
        DO 210 IPAN=1,NPAN                  !!! over panels
	DO 20 IPNT=1,NPNT
	DO 10 IBND=1,NBNDT(IPAN)
	WEIGH(IBND,IPNT,IPAN)=0.D0
	WEIGD(IBND,IPNT,IPAN)=0.D0
  10    CONTINUE
  20    CONTINUE
        DO 160 I3=0,NDIV(3)-1               !!! over cells along G3
        DO 160 I2=0,NDIV(2)-1               !!! over cells along G2
        DO 160 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRA INSIDE MICROCELL
        DO 150 ITTR=1,6                     !!! over tetrahedra
        DO 110 I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
        J1=I1+KCUT(1,I,ITTR)
        J2=I2+KCUT(2,I,ITTR)
        J3=I3+KCUT(3,I,ITTR)
        KTT(I)=IPQ(J1,J2,J3)
 110	CONTINUE
	DO 140 IBND=1,NBNDT(IPAN)                  !!! over valence bands
	DO 120 I=1,4
	IPNT=KTT(I)
	E(I)=EARR(IBND,IPNT,IPAN)
 120    CONTINUE
	CALL INTEGR1(E,EF,OT,AT,AD,TS,DS)
	TOS=TOS+TS
	DOS=DOS+DS
	DO 130 I=1,4
	IPNT=KTT(I)
	WEIGH(IBND,IPNT,IPAN)=WEIGH(IBND,IPNT,IPAN)+AT(I)
	WEIGD(IBND,IPNT,IPAN)=WEIGD(IBND,IPNT,IPAN)+AD(I)
 130	CONTINUE
 140    CONTINUE                                  !!! over valence bands
 150    CONTINUE                                  !!! over tetrahedra
 160    CONTINUE                                  !!! over N1,N2,N3
	DO 180 IPNT=1,NPNT
	DO 170 IBND=1,NBNDT(IPAN)
	WEIGH(IBND,IPNT,IPAN)=WEIGH(IBND,IPNT,IPAN)/
     &  VOLIBZ*2.D0
	WEIGD(IBND,IPNT,IPAN)=WEIGD(IBND,IPNT,IPAN)/
     &  VOLIBZ*2.D0
	TOT=TOT+WEIGH(IBND,IPNT,IPAN)
	DOT=DOT+WEIGD(IBND,IPNT,IPAN)
 170    CONTINUE
 180    CONTINUE
 210    CONTINUE                                  !!! over panels
C ************ END OF INTEGRATION ***********
	TOS=TOS/VOLIBZ*2.D0
	DOS=DOS/VOLIBZ*2.D0
	IF(KEY.EQ.0)WRITE(IUN,1000)EF,TOS,DOS
	IF(ABS(TOS-TOT).GE.1.D-07)WRITE(IUN,1010)TOS,TOT
	IF(ABS(DOS-DOT).GE.1.D-07)WRITE(IUN,1020)DOS,DOT
1000    FORMAT(' EF,TOS,DOS==',3(1X,G14.7))
1010    FORMAT(' TOS-WEIGHTS MISMATCH :',G14.7,2X,G14.7)
1020    FORMAT(' DOS-WEIGHTS MISMATCH :',G14.7,2X,G14.7)
	RETURN
	END



	SUBROUTINE INTEGR1(E0,EF,OT,AT,AD,TS,DS)
********************************************************
*  Integration over microtetrahedron.                  *
*  Iblo=0 - standard tetrahedron method,               *
*  Iblo=1 - with Bloechl corrections.                  *
********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION ET(4),A(4),E0(4),IND(4),L(4),AT(4),AD(4)
	LOGICAL GF
        DATA IBLO/1/ !!! KEY FOR BLOECHL CORRECTION
	GF(X)=EF.GT.X
	DF(X)=EF-X
C
	DO 10 I=1,4
	AT(I)=0.D0
	AD(I)=0.D0
  10    IND(I)=1
	DO 30 I=1,3
	I1=I+1
	DO 30 J=I1 ,4
	IF(E0(I).GT.E0(J))GOTO20
	IND(I)=IND(I)+1
	GOTO 30
  20    IND(J)=IND(J)+1
  30    CONTINUE
	DO 40 I=1,4
	JJ=IND(I)
	L(JJ)=I
  40    ET(JJ)=E0((I))
	IF(GF(ET(4))) GOTO 60
	TS=0.D0
	DS=0.D0
	DO 50 I=1,4
	AT(I)=0.D0
	AD(I)=0.D0
  50    CONTINUE
	RETURN
  60    IF(.NOT. GF(ET(1))) GOTO 80 
	TS=OT
	DS=0.D0
	DO 70 I=1,4
	AD(I)=0.D0
	AT(I)=OT/4.D0
  70    CONTINUE
	RETURN
  80    IF(.NOT. GF(ET(3))) THEN
	EF4=DF(ET(4))
	E24=EF4/(ET(2)-ET(4))
	E14=EF4/(ET(1)-ET(4))
	E34=EF4/(ET(3)-ET(4))
	TMP=E24*E14*E34*OT
	DS=TMP*3.D0/EF4
	DDS=DS*2.D0/EF4       !!! dD(Ef)/dEf for Bloechl correction
	TS=TMP
	AD(L(1))=DS*E14/3.D0
	AD(L(2))=DS*E24/3.D0
	AD(L(3))=DS*E34/3.D0
	AD(L(4))=DS*(1.D0-(E14+E24+E34)/3.D0)
	AT(L(1))=TS*E14/4.D0
	AT(L(2))=TS*E24/4.D0
	AT(L(3))=TS*E34/4.D0
	AT(L(4))=TS*(1.D0-(E14+E24+E34)/4.D0)
	ELSEIF(GF(ET(3)) .AND. (.NOT. GF(ET(2)))) THEN
C SECTION IS A QUADRANGLE
	OM23=ET(2)-ET(3)
C DIVIDING INTO TWO TETRAHEDRA
C THE FIRST TETRAHEDRON
	DOM1=DF(ET(4))
	DOM11=ET(1)-ET(4)
	DOM12=ET(2)-ET(4)
	DOM13=DOM1
	F1=1.D0/DOM11/DOM12*(ET(2)-EF)/OM23
C THE SECOND TETRAHEDRON
	DOM2=-DF(ET(1))
	DOM21=DOM2
	DOM22=ET(1)-ET(3)
	DOM23=ET(1)-ET(4)
	F2=1.D0/DOM22/DOM23
	G2=(EF-ET(3))/OM23
	DS=(DOM1*F1+DOM2*F2*G2)*3.D0*OT
	DDS=(DOM2/DOM22-DOM1/DOM12)/DOM11/OM23*6.D0*OT
	TS=(DOM1**2*F1+(1.D0-DOM2**2*F2)*G2)*OT
	DF1=3.D0*OT*DOM1*F1
	TF1=OT*DOM1*F1*DOM1
	DF2=3.D0*OT*DOM2*F2*G2
	TF2=OT*DOM2*F2*G2*DOM2
	DFF=DF(ET(3))/(ET(2)-ET(3))
	AD(L(1))=DF2*(1.D0-DOM2/3.D0*(1.D0/DOM21+1.D0/DOM22+
     &  1.D0/DOM23))+DF1*DOM1/DOM11/3.D0
	AD(L(2))=DF1*DOM1/3.D0*(1.D0/DOM12+1.D0/DOM13*DFF)+
     &  DF2*DOM2/DOM21/3.D0*DFF
	AD(L(3))=DF2*DOM2/3.D0*(1.D0/DOM21+1.D0/DOM22-
     &  1.D0/DOM21*DFF)+DF1*DOM1/DOM13/3.D0*(1.D0-DFF)
	AD(L(4))=DF1*(1.D0-DOM1/3.D0*(1.D0/DOM11+1.D0/DOM12+
     &  1.D0/DOM13))+DF2*DOM2/DOM23/3.D0
	AT(L(1))=-TF2*(1.D0-DOM2/4.D0*(1.D0/DOM21+1.D0/DOM22+
     &  1.D0/DOM23))+TF1*DOM1/DOM11/4.D0+OT*G2/4.D0
	AT(L(2))=TF1*DOM1/4.D0*(1.D0/DOM12+1.D0/DOM13*DFF)-
     &  TF2*DOM2/DOM21/4.D0*DFF+OT*G2/4.D0*DFF
	AT(L(3))=-TF2*DOM2/4.D0*(1.D0/DOM21+1.D0/DOM22-
     &  1.D0/DOM21*DFF)+TF1*DOM1/DOM13/4.D0*(1.D0-DFF)+
     &  OT*G2/4.D0*(2.D0-DFF)
	AT(L(4))=TF1*(1.D0-DOM1/4.D0*(1.D0/DOM11+1.D0/DOM12+
     &  1.D0/DOM13))-TF2*DOM2/DOM23/4.D0+OT*G2/4.D0
	ELSEIF(GF(ET(2))) THEN
	EF1=DF(ET(1))
	E14=EF1/(ET(1)-ET(4))
	E12=EF1/(ET(1)-ET(2))
	E13=EF1/(ET(1)-ET(3))
	TMP=E12*E13*E14*OT
C   !NB TMP<0,EF1<0
	DS=TMP*3.D0/EF1
	DDS=DS*2.D0/EF1
	TS=OT+TMP
	AD(L(1))=DS*(1.D0+(E12+E13+E14)/3.D0)
	AD(L(2))=-DS*E12/3.D0
	AD(L(3))=-DS*E13/3.D0
	AD(L(4))=-DS*E14/3.D0
	AT(L(1))=OT/4.D0+TMP*(1.D0+(E12+E13+E14)/4.D0)
	AT(L(2))=OT/4.D0-TMP*E12/4.D0
	AT(L(3))=OT/4.D0-TMP*E13/4.D0
	AT(L(4))=OT/4.D0-TMP*E14/4.D0
	ENDIF
CKH ***** BLOECHL CORRECTION *************
	IF(IBLO.EQ.1)THEN
	DO 90 I=1,4
	DO 90 J=1,4
	AT(L(I))=AT(L(I))+(ET(J)-ET(I))*DS*0.025D0
	AD(L(I))=AD(L(I))+(ET(J)-ET(I))*DDS*0.025D0
 90     CONTINUE
	ENDIF
	RETURN
	END
