	PROGRAM MAKEMESH
*************************************************************
*  The program calculates cubic mesh with the energy band   *
*  for finding the Fermi surface.                           *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NPNT0(NPANMAX),NPNT(NPANMAX),NDIV(3),NDIC(3)
     &	 ,IGQ(0:50,0:50,0:50),IPQ(0:50,0:50,0:50),KCUT(3,4,6)
     &   ,IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSW(NSORTMAX)
     &   ,IREF(0:NVCMAX),KVEC(3,0:NVCMAX)
	DIMENSION EARR(NDIMMAX,KMAX,NPANMAX,NSPINMAX),ORTH(2:3)
     &   ,PNT0(3,KMAX,NPANMAX),PNT(3,KMAX,NPANMAX)
	DIMENSION A(3,3),TAU(3,NPAT),AK(3,3,2),RK(3,3,2)
     &    ,TAU0(3,NPAT),G(3,3),C0(3),C1(3),C2(3),C3(3)
     &    ,GVEC(3,0:NVCMAX),TU(3)
        CHARACTER*60 BNDFILE,STRFILE,CONFILE,SRFFILE,KOVFILE,INIFILE
        CHARACTER SYS*1
	COMMON /LATTICE/A,G,AK,RK                       !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSW,NATOM   !!! from init
	COMMON /BASIS0/ TAU0                            !!! from init
	COMMON /JMINMAX/JMIN,JMAX                       !!! from init
	COMMON /ENERGY/ EARR
	COMMON /LATPAR/ PAR,ORTH                        !!! for strmsh
	COMMON /BASIS/  TAU                             !!! from init
	COMMON /OUT1/   ISS,ISRF,IKOV                   !!! from init
	COMMON /INTTR/  NDIV,NDIC                       !!! from init
	COMMON /TMESH/  NPNT0,PNT0                      !!! from init
	COMMON /GROUPOUT/NGROUP
	COMMON /MESH/   NPNT,PNT                        !!! from bzmesh
	COMMON /ORBS/   NORBS
	COMMON /SPIN/   NSPIN
	COMMON /WMESH/  KCUT,IPQ,IGQ                    !!! from bzmesh
	COMMON /OUT2/   CONFILE,SRFFILE,KOVFILE         !!! from init
	DATA EPS/1.D-05/,TU/0.D0,0.D0,0.D0/,IUN/6/
        PRINT1010
        READ(5,1030)BNDFILE
        PRINT1015
        READ(5,1030)INIFILE
        PRINT1020
        READ(5,1030)STRFILE
        CALL READBND(BNDFILE)
        CALL READINI(INIFILE)
        CALL READSTR(STRFILE)
C  CALUCLATE POINT GROUP
        IF(IKOV.EQ.1)SYS='C'
        IF(IKOV.EQ.2)SYS='H'
        IF(IKOV.EQ.3)SYS='A'
        CALL WIGMAT(2,SYS,KOVFILE)
        CALL GROUPS(A,TAU0,IS,2,NATOM,NSPIN,NORBS,EPS,1)
        WRITE(IUN,1040)NGROUP
        CALL WIGMAT(2,SYS,KOVFILE)
        CALL GROUPS(A,TAU, IS,2,NATOM,NSPIN,NORBS,EPS,2)
        WRITE(IUN,1050)NGROUP
C  CALCULATE TETRAHEDRON MESH
	CALL SBZMESH(NDIV,NDIC)
        WRITE(IUN,1060)NPNT(1)
C  CHECK K-POINT ARRAY
	IF(NPNT(1).NE.NPNT0(1))STOP' # of k-points mismatches'
	DO 10 IPNT=1,NPNT(1)
C 	IF(ABS(PNT(1,IPNT,1)-PNT0(1,IPNT,1)).GE.1.D-04.OR.
C    &     ABS(PNT(2,IPNT,1)-PNT0(2,IPNT,1)).GE.1.D-04.OR.
C    &     ABS(PNT(3,IPNT,1)-PNT0(3,IPNT,1)).GE.1.D-04)
C    &  STOP'k-points mismatch'
  10	CONTINUE
C  READ MESH DATA
	PRINT*,'ENTER CUBIC TRANSLATIONS:'
	READ(5,*)C1,C2,C3
	PRINT*,'ENTER DIVISIONS  OF THEM:'
	READ(5,*)N1,N2,N3
	PRINT*,'ENTER ORIGIN (e.g 0,0,0):'
	READ(5,*)C0
	PRINT*,'MIN/MAX # OF BANDS ARE:',JMIN+1,JMAX-1
	PRINT*,'ENTER # OF BANDS AT EF :'
	READ(5,*)JMIN,JMAX
	DO 20 J=2,3
	C0(J)=C0(J)/ORTH(J)
	C1(J)=C1(J)/ORTH(J)
	C2(J)=C2(J)/ORTH(J)
	C3(J)=C3(J)/ORTH(J)
  20    CONTINUE
C  FIND SPHERE RADIUS CIRCUMSCRIBING BZ
        RMAX=0.D0
        DO 40 IZ=-1,1
        DO 40 JZ=-1,1
        DO 40 KZ=-1,1
        RSUM=0.D0
        DO 30 I=1,3
        RSUM=RSUM+(IZ*AK(I,1,1)*NDIV(1)+JZ*AK(I,2,1)*NDIV(2)+
     &  KZ*AK(I,3,1)*NDIV(3))**2
  30    CONTINUE
        RMAX=MAX(RMAX,RSUM)
  40    CONTINUE
        RMAX=SQRT(RMAX)+0.1D0
C  GENERATE ALL RECIPROCAL LATTICE VECTORS INSIDE SPHERE "RMAX"
        CALL SITEGEN(RMAX,G(1,1),G(1,2),G(1,3),TU,1,NVEC,
     &  GVEC,IREF)
        NVEC=NVEC-1
        DO 50 IVEC=0,NVEC
        X1=GVEC(1,IVEC)*RK(1,1,1)+GVEC(2,IVEC)*RK(2,1,1)+
     &  GVEC(3,IVEC)*RK(3,1,1)
        X2=GVEC(1,IVEC)*RK(1,2,1)+GVEC(2,IVEC)*RK(2,2,1)+
     &  GVEC(3,IVEC)*RK(3,2,1)
        X3=GVEC(1,IVEC)*RK(1,3,1)+GVEC(2,IVEC)*RK(2,3,1)+
     &  GVEC(3,IVEC)*RK(3,3,1)
        KVEC(1,IVEC)=ANINT(X1)
        KVEC(2,IVEC)=ANINT(X2)
        KVEC(3,IVEC)=ANINT(X3)
        IF(ABS(KVEC(1,IVEC)-X1).GE.1.D-05.OR.
     &  ABS(KVEC(2,IVEC)-X2).GE.1.D-05.OR.
     &  ABS(KVEC(3,IVEC)-X3).GE.1.D-05)STOP'<BZMESH>:
     &  ERROR IN RECIPROCAL LATTICE VECTORS'
  50    CONTINUE
C  DO OVER MESH GENERATED IN CUBIC TRANSLATIONS
	ISPIN=1
	DO 120 I3=0,N3
	DO 110 I2=0,N2
	DO 100 I1=0,N1
	XK=C1(1)/DBLE(N1)*I1+C2(1)/DBLE(N2)*I2+C3(1)/DBLE(N3)*I3-C0(1)
	YK=C1(2)/DBLE(N1)*I1+C2(2)/DBLE(N2)*I2+C3(2)/DBLE(N3)*I3-C0(2)
	ZK=C1(3)/DBLE(N1)*I1+C2(3)/DBLE(N2)*I2+C3(3)/DBLE(N3)*I3-C0(3)
C  REDUCE TO FIRST CELL
        FI1=XK*RK(1,1,1)+YK*RK(2,1,1)+ZK*RK(3,1,1)
        FI2=XK*RK(1,2,1)+YK*RK(2,2,1)+ZK*RK(3,2,1)
        FI3=XK*RK(1,3,1)+YK*RK(2,3,1)+ZK*RK(3,3,1)
	IF1=ANINT(FI1)
	IF2=ANINT(FI2)
	IF3=ANINT(FI3)
	IF(ABS(IF1-FI1).GE.1.D-05.OR.ABS(IF2-FI2).GE.1.D-05.OR.
     &     ABS(IF3-FI3).GE.1.D-05)STOP'k-point cannot be reduced'
C  REDUCE THE POINT TO THE BRILLOUIN ZONE
        NRED=0
        DO 60 IVEC=0,NVEC
        IR1=IF1+KVEC(1,IVEC)
        IR2=IF2+KVEC(2,IVEC)
        IR3=IF3+KVEC(3,IVEC)
        IF((IR1.GE.0.AND.IR1.LE.NDIV(1)).AND.(IR2.GE.0.AND.IR2.
     &  LE.NDIV(2)).AND.(IR3.GE.0.AND.IR3.LE.NDIV(3)))GOTO70
C  THE POINT IS REDUCED TO THE BRILLOUIN ZONE BY VECTOR IVEC
  60	CONTINUE
	STOP' THE POINT IS NOT REDUCED TO THE BZ'
C  GET IRREDUCIBLE POINT NUMBER
  70	IRRPNT=IPQ(IR1,IR2,IR3)
C  WRITE ENERGY BANDS AT THIS POINT
 	WRITE(1,1070)I1,I2,I3,(EARR(J,IRRPNT,1,ISPIN),J=JMIN,JMAX) 
C	WRITE(1,1080)(EARR(J,IRRPNT,1,ISPIN),J=JMIN,JMAX) 
 100	CONTINUE
 110	CONTINUE
 120	CONTINUE
	CLOSE(1)
1000    FORMAT(A)
1010    FORMAT(1X,'BNDFILE? ',$)
1015    FORMAT(1X,'INIFILE? ',$)
1020    FORMAT(1X,'STRFILE? ',$)
1030    FORMAT(A)
1040    FORMAT(1X,I4,' elements discovered for original   lattice')
1050    FORMAT(1X,I4,' elements found      for distorted  lattice')
1060    FORMAT(1X,I4,' k-points generated  for main valence panel')
1070	FORMAT(1X,I2,1X,I2,1X,I2,1X,5(G12.5,1X))
1080	FORMAT(1X,5(G12.5,1X))
	END





	SUBROUTINE READBND(BNDFILE)
************************************************************
*  <READBND> reads band structure.                         *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NPNT(NPANMAX),NDIV(3),NDIC(3),NBNDF(NPANMAX)
     &   ,NBNDE(NPANMAX),NBNDT(NPANMAX)
	CHARACTER*60 BNDFILE
	DIMENSION EARR(NDIMMAX,KMAX,NPANMAX,NSPINMAX)
     &   ,PNT(3,KMAX,NPANMAX)
	COMMON /SPIN/   NSPIN
	COMMON /INTTR/  NDIV,NDIC
	COMMON /JMINMAX/JMIN,JMAX                       !!! from init
	COMMON /EFERMI/ EF
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT
	COMMON /ENERGY/ EARR
	COMMON /TMESH/  NPNT,PNT
        OPEN(3,FILE=BNDFILE,STATUS='OLD')
        READ(3,*)EF,NPNT(1),NDIV(1),NDIV(2),NDIV(3),NBNDT(1),NSPIN
	IF(NSPIN.EQ.2)STOP' Spin-polarization not ready'
	IF(NPNT(1).GT.KMAX)STOP'NPNT > KMAX, CHECK PARAM.DAT'
	IF(NBNDT(1).GT.NDIMMAX)STOP'NBNDF > NDIMMAX, CHECK PARAM.DAT'
        DO 20 IPNT=1,NPNT(1)
        READ(3,*)(PNT(J,IPNT,1),J=1,3)
        DO 10 ISPIN=1,NSPIN
        READ(3,*)(EARR(J,IPNT,1,ISPIN),J=1,NBNDT(1))
  10    CONTINUE
  20    CONTINUE
        CLOSE(3)
	NDIC(1)=1
	NDIC(2)=1
	NDIC(3)=1
	DO 40 IBND=1,NBNDT(1)
	IKEY1=0
	DO 30 IPNT=1,NPNT(1)
	IF(EARR(IBND,IPNT,1,1).LT.EF)IKEY1=IKEY1+1
  30	CONTINUE
	IF(IKEY1.EQ.NPNT(1))JMIN=IBND
  40	CONTINUE
	DO 60 IBND=NBNDT(1),1,-1
	IKEY2=0
	DO 50 IPNT=1,NPNT(1)
	IF(EARR(IBND,IPNT,1,1).GT.EF)IKEY2=IKEY2+1
  50	CONTINUE
	IF(IKEY2.EQ.NPNT(1))JMAX=IBND
  60	CONTINUE
	END





        SUBROUTINE READINI(INIFILE)
************************************************************
*  <READINI> reads control parameters,atomic stucture data *
*  iterative procedures limits and accuracy parameters     *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER IS(NPAT),ILS(NSORTMAX),NSHE(NSORTMAX)
     &   ,NPOL(0:NSORTMAX)
        DIMENSION Z(NSORTMAX),ZCORE(NSORTMAX),SROU(NSORTMAX)
        CHARACTER*60 INIFILE,TXTEL(NSORTMAX)*10
        COMMON /PARAM/   NSORT,IS
        COMMON /POTCOM/  SWZ,SMT(NSORTMAX)
	COMMON /KAPPAR/  NPAN                                !!! from init
        COMMON /LATPAR/  PAR
        COMMON /INTMESH/ NSHE,NPOL,SROU
	COMMON /ORBS/    NORBS
	COMMON /SPIN/    NSPIN
        COMMON /SRFINP/  SW(NSORTMAX)
        COMMON /TXTEL/   TXTEL
        DATA PI/3.141592653589793D0/
	NPAN=1
        OPEN(1,FILE=INIFILE,STATUS='OLD')
        DO 10 I=1,13
        READ(1,*)
  10    CONTINUE
        READ(1,*)NATOM,NSORT,NSPIN,NORBS
        READ(1,*)PAR
        READ(1,*)(IS(I),I=1,NATOM)
        READ(1,*)NKAP
        DO 40 ISORT=1,NSORT
        READ(1,1000)TXTEL(ISORT)
        READ(1,*)Z(ISORT),ZCORE(ISORT)
        READ(1,*)SMT(ISORT),SROU(ISORT),SW(ISORT)
        READ(1,*)LMT,LMB,ILS(ISORT)
        READ(1,*)
        DO 20 IKAP=1,NKAP
        READ(1,*)
        READ(1,*)
        READ(1,*)
        READ(1,*)
        READ(1,*)
        READ(1,*)
  20    CONTINUE
        READ(1,*)
        READ(1,*)NC
        DO 30 IC=1,NC
        READ(1,*)
  30    CONTINUE
  40    CONTINUE
        CLOSE(1)
1000    FORMAT(A60)
        END



        SUBROUTINE READSTR(STRFILE)
************************************************************
*  <READSTR> reads crystalline structure and IBZ data      *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        CHARACTER*60 STRFILE,KOVFILE,CONFILE,FTRFILE,SYS*1,TXT*72
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSW(NSORTMAX)
     &    ,NDIV(3),NDIC(3)
        DIMENSION RBASR(3,3),TAUR(3,NPAT),BASR(3),BBASR(3,3),ORTH(2:3)
     &    ,GBAS(3,3),RBAS(3,3),BBAS(3,3),TAU(3,NPAT),STRAIN(3,3,2)
     &    ,SH(3,NPANMAX),AK(3,3,2),RK(3,3,2),HSPNT(3,2,KMAX)
     &    ,HSPNTR(3,2,KMAX),RSTN(3,3),TAU0(3,NPAT),TAU0R(3,NPAT)
        CHARACTER PNTNOT(2,KMAX)*1,TEXT*64,TEXTS*64,STRING(80)*1
        COMMON /LATTICE/RBAS,GBAS,AK,RK                 !!! from init
        COMMON /MANSTR/ ISTRAIN,IBAS,IBZ,ICALC          !!! from init
        COMMON /BASIS/  TAU                             !!! from init
        COMMON /BASIS0/ TAU0                            !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSW,NATOM   !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN          !!! from init
        COMMON /OUT1/   ICON,IFTR,IKOV                  !!! from init
        COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE         !!! from init
        COMMON /INTTR/  NDIV,NDIC,SH,NDIR,HSPNT         !!! from init
        COMMON /HSPNTS/ PNTNOT                          !!! from init
        COMMON /STRINP/ NVECMX,ALPHA                    !!! from init
        COMMON /SRFINP/ NDIV1,NDIV2                     !!! from init
        COMMON /TEXT/   TEXT,TEXTS                      !!! from init
        COMMON /UNIT/   IUN                             !!! from init
        DATA PI/3.141592653589793D0/
C--------------------------------------------
C***** INPUT FILE 3 FOR NMT-PACK ************
C--------------------------------------------
        OPEN(UNIT=1,FILE=STRFILE,STATUS='OLD')
        READ(1,1000)TEXTS
C  **** MAIN PARAMETERS *********************
C  ORTH  - ortorhombicity, i.e. b/a, c/a
C  IBAS  - if 1 then Cartesian, else in RBAS
C  IBZ   - if 1 then from RBAS, else input
C  ICALC - if 1 using the calculator
C  ISTRAIN - if 1 plane waves follow the distortions
C  NDIV1 - generation of polyhedra parameter
C  NDIV2 - polyhedron surface mesh parameter
C  NVECMX - number of structure vectors
C  ALPHA - Evald's splitting parameter
        READ(1,1001)TXT
        READ(1,*) NATOM,ORTH
        READ(1,*) IBAS,IBZ,ICALC,ISTRAIN
        READ(1,*) NDIV1,NDIV2
        READ(1,*) NVECMX,ALPHA
C  **** PRIMITIVE TRANSLATIONS **************
C  RBAS(1:3,IVEC) - x,y,z components of translations
        READ(1,1000)TXT
        DO 10 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(RBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,RBASR(1,IVEC),3)
        ENDIF
  10    CONTINUE
C  **** BASIS ATOMS IN ORIGINAL CELL ****************
C  TAU0  - positions of atoms in original cell
        READ(1,1000)TXT
        DO 15 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAU0R(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAU0R(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAU0R(1,IATOM)=BASR(1)*RBASR(1,1)
     &                +BASR(2)*RBASR(1,2)
     &                +BASR(3)*RBASR(1,3)
        TAU0R(2,IATOM)=BASR(1)*RBASR(2,1)
     &                +BASR(2)*RBASR(2,2)
     &                +BASR(3)*RBASR(2,3)
        TAU0R(3,IATOM)=BASR(1)*RBASR(3,1)
     &                +BASR(2)*RBASR(3,2)
     &                +BASR(3)*RBASR(3,3)
        ENDIF
  15    CONTINUE
C  **** BASIS ATOMS IN DISTORTED CELL ****************
C  TAU  - actual positions of atoms
        READ(1,1000)TXT
        DO 20 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAUR(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAUR(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAUR(1,IATOM)=BASR(1)*RBASR(1,1)
     &               +BASR(2)*RBASR(1,2)
     &               +BASR(3)*RBASR(1,3)
        TAUR(2,IATOM)=BASR(1)*RBASR(2,1)
     &               +BASR(2)*RBASR(2,2)
     &               +BASR(3)*RBASR(2,3)
        TAUR(3,IATOM)=BASR(1)*RBASR(3,1)
     &               +BASR(2)*RBASR(3,2)
     &               +BASR(3)*RBASR(3,3)
        ENDIF
  20    CONTINUE
C  **** STRAIN MATRIX ***********************                      _
C  STRAIN(1..3,1..3) - matrix applied to translations and basis R'=S*R
C  Its diagonal components in case no strain are just 1,1,1
        READ(1,1000)TXT
        DO 30 I=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(STRAIN(I,J,1),J=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        STRAIN(I,1,1)=BASR(1)
        STRAIN(I,2,1)=BASR(2)
        STRAIN(I,3,1)=BASR(3)
        ENDIF
  30    CONTINUE
C  SET RECIPROCAL STRAIN MATRIX: S*S^(-1)=1
        CALL CROSS(RSTN(1,1),STRAIN(1,2,1),STRAIN(1,3,1))
        CALL CROSS(RSTN(1,2),STRAIN(1,3,1),STRAIN(1,1,1))
        CALL CROSS(RSTN(1,3),STRAIN(1,1,1),STRAIN(1,2,1))
        W=STRAIN(1,1,1)*RSTN(1,1)
     &   +STRAIN(2,1,1)*RSTN(2,1)
     &   +STRAIN(3,1,1)*RSTN(3,1)
        IF(ABS(W).LE.1.D-10)STOP'<READSTR>:: WRONG STRAIN, DET=0'
        DO 40 I=1,3
        STRAIN(1,I,2)=RSTN(I,1)/W
        STRAIN(2,I,2)=RSTN(I,2)/W
        STRAIN(3,I,2)=RSTN(I,3)/W
  40    CONTINUE
C  **** POINT GROUP DESCRIPTION *************
C  SYS - C(cubic) or H(hexogonal) system of rotations
C      - A(arbitrary) system can be also specified.
C        Group operations must be listed in KOVFILE,
C        see WIGMAT subroutine for more details.
        READ(1,1000)TXT
        READ(1,*)SYS
        IF(SYS.EQ.'C')IKOV=1
        IF(SYS.EQ.'H')IKOV=2
        IF(SYS.EQ.'A')IKOV=3
        IF(IKOV.EQ.3)THEN
        BACKSPACE(1)
        READ(1,*)SYS,KOVFILE
        ENDIF
C  ****  BRILLOUIN ZONE **********
C  BBAS - three primitive translations (possibly reciprocal lattice vectors)
        READ(1,1000)TXT
        DO 50 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(BBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BBASR(1,IVEC),3)
        ENDIF
  50    CONTINUE
C  **** HIGH-SYMMETRY DIRECTION SETTINGS ****
C  NDIR - number of directions to be calculated
C  HSPNT(1:3,1:2,IDIR) - starting and end points
        READ(1,1000)TXT
        READ(1,*)NDIR                             !!! # of h.s. directions
        IF(NDIR.GT.KMAX)STOP'<READSTR>: # OF DIRECTIONS IS TOO LARGE,
     &  ALLOWED # IS EQUAL TO KMAX'
        DO 60 IDIR=1,NDIR
        READ(1,1010)(PNTNOT(IVEC,IDIR),IVEC=1,2)
        IF(ICALC.NE.1)THEN
        READ(1,*)((HSPNTR(I,IVEC,IDIR),I=1,3),IVEC=1,2) ! high-symmetry dirs
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,HSPNTR(1,1,IDIR),6)
        ENDIF
  60    CONTINUE
        CLOSE(1)
C  ACCOUNT FOR ORTHOROMBICITY PARAMETERS
        DO 90 I=2,3
        DO 70 IVEC=1,3
        RBASR(I,IVEC)=RBASR(I,IVEC)*ORTH(I)
        BBASR(I,IVEC)=BBASR(I,IVEC)/ORTH(I)
  70    CONTINUE
        DO 80 IATOM=1,NATOM
        TAU0R(I,IATOM)=TAU0R(I,IATOM)*ORTH(I)
        TAU R(I,IATOM)=TAU R(I,IATOM)*ORTH(I)
  80    CONTINUE
  90    CONTINUE
        DO 130 I=2,3
        DO 120 IVEC=1,2
        DO 110 IDIR=1,NDIR
        HSPNTR(I,IVEC,IDIR)=HSPNTR(I,IVEC,IDIR)/ORTH(I)
 110    CONTINUE
 120    CONTINUE
 130    CONTINUE
C  APPLY STRAIN MATRIX FOR TRANSLATIONS:  R'=S*R
        DO 150 IVEC=1,3
        DO 150 I=1,3
        RBAS(I,IVEC)=0.D0
        DO 140 J=1,3
        RBAS(I,IVEC)=RBAS(I,IVEC)+STRAIN(I,J,1)*RBASR(J,IVEC)
 140    CONTINUE
 150    CONTINUE
C  APPLY STRAIN FOR BASIS VECTORS:  T'=S*T
        DO 170 IATOM=1,NATOM
        DO 170 I=1,3
        TAU (I,IATOM)=0.D0
        TAU0(I,IATOM)=0.D0
        DO 160 J=1,3
        TAU (I,IATOM)=TAU (I,IATOM)+STRAIN(I,J,1)*TAU R(J,IATOM)
        TAU0(I,IATOM)=TAU0(I,IATOM)+STRAIN(I,J,1)*TAU0R(J,IATOM)
 160    CONTINUE
 170    CONTINUE
C  APPLY INVERSE STRAIN FOR BRILLOUIN ZONE: BZ'=BZ*S^(-1)
        DO 190 IVEC=1,3
        DO 190 I=1,3
        BBAS(I,IVEC)=0.D0
        DO 180 J=1,3
        BBAS(I,IVEC)=BBAS(I,IVEC)+BBASR(J,IVEC)*STRAIN(J,I,2)
 180    CONTINUE
 190    CONTINUE
C  APPLY INVERSE STRAIN TO HIGH-SYMMETRY DIRECTIONS: K'=K*S^(-1)
        DO 220 IDIR=1,NDIR
        DO 220 IVEC=1,2
        DO 220 I=1,3
        HSPNT(I,IVEC,IDIR)=0.D0
        DO 210 J=1,3
        HSPNT(I,IVEC,IDIR)=HSPNT(I,IVEC,IDIR)+
     &  HSPNTR(J,IVEC,IDIR)*STRAIN(J,I,2)
 210    CONTINUE
 220    CONTINUE
C  SET RECIPROCAL LATTICE VECTORS WITHOUT 2*PI
        CALL CROSS(GBAS(1,1),RBAS(1,2),RBAS(1,3))
        CALL CROSS(GBAS(1,2),RBAS(1,3),RBAS(1,1))
        CALL CROSS(GBAS(1,3),RBAS(1,1),RBAS(1,2))
        W=RBAS(1,1)*GBAS(1,1)
     &   +RBAS(2,1)*GBAS(2,1)
     &   +RBAS(3,1)*GBAS(3,1)
        DO 230 I=1,3
        GBAS(I,1)=GBAS(I,1)/W
        GBAS(I,2)=GBAS(I,2)/W
        GBAS(I,3)=GBAS(I,3)/W
 230    CONTINUE
        OMEGAC=ABS(W)*PAR**3
C  SET BRILLOUIN ZONE TO GBAS IF REQUIRED
        IF(IBZ.EQ.1)THEN
        DO 240 I=1,3
        BBAS(I,1)=GBAS(I,1)
        BBAS(I,2)=GBAS(I,2)
        BBAS(I,3)=GBAS(I,3)
 240    CONTINUE
        ENDIF
C  SET PRIMITIVE TRANSLATIONS FOR BZ AND PRIMITIVE CELL
        DO 250 I=1,3
        AK(I,1,1)=BBAS(I,1)/NDIV(1)
        AK(I,2,1)=BBAS(I,2)/NDIV(2)
        AK(I,3,1)=BBAS(I,3)/NDIV(3)
        AK(I,1,2)=BBAS(I,1)/NDIC(1)
        AK(I,2,2)=BBAS(I,2)/NDIC(2)
        AK(I,3,2)=BBAS(I,3)/NDIC(3)
 250    CONTINUE
C  SET TRANSLATIONS WHICH ARE RECIPROCAL TO AK AND AD
        DO 270 IP=1,2
        CALL CROSS(RK(1,1,IP),AK(1,2,IP),AK(1,3,IP))
        CALL CROSS(RK(1,2,IP),AK(1,3,IP),AK(1,1,IP))
        CALL CROSS(RK(1,3,IP),AK(1,1,IP),AK(1,2,IP))
        WK=AK(1,1,IP)*RK(1,1,IP)+AK(2,1,IP)*RK(2,1,IP)+
     &  AK(3,1,IP)*RK(3,1,IP)
        DO 260 I=1,3
        RK(I,1,IP)=RK(I,1,IP)/WK
        RK(I,2,IP)=RK(I,2,IP)/WK
        RK(I,3,IP)=RK(I,3,IP)/WK
 260    CONTINUE
 270    CONTINUE
1000    FORMAT(A)
1001    FORMAT(/A)
1010    FORMAT(2(1X,A1))
1020    FORMAT(80A1)
        END






        SUBROUTINE CROSS(A,B,C)
**********************************************************
*    Cross product (AX,AY,AZ)=(BX,BY,BZ)*(CX,CY,CZ)      *
**********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION A(3),B(3),C(3)
        A(1)=B(2)*C(3)-B(3)*C(2)
        A(2)=B(3)*C(1)-B(1)*C(3)
        A(3)=B(1)*C(2)-B(2)*C(1)
        RETURN
        END

