	IMPLICIT REAL*8 (A-H,O-Z)
******************************************************************
*  Rewrites FATFILE from NMT programs to the BNDS and EIGN files *
*  of the TB-LMTO Stuttgart in order to plot fat bands.          *
******************************************************************
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILSB(NSORTMAX),NHSORT(NSORTMAX)
	DIMENSION TLMC(LIMLMB,NPAT,NSPINMAX)
     &    ,TLM(LIMLMB,NPAT),EARR(NDIMMAX,KMAX),PNT(3,KMAX)
	COMPLEX TVEC(NDIMMAX,NDIMMAX)
	REAL ERL(NDIMMAX)
	CHARACTER*60 FATFILE,OUTFILE
	CHARACTER TLAB(NSORTMAX)*4,TXTEL(NSORTMAX)*10,PNTNOT(2,KMAX)*1 
        PRINT1010
        READ(5,1020)FATFILE
	OPEN(UNIT=1,FILE=FATFILE,STATUS='OLD',ACCESS='SEQUENTIAL',
     &  FORM='UNFORMATTED')
	OPEN(UNIT=2,FILE='EIGN',STATUS='NEW',ACCESS='SEQUENTIAL',
     &  FORM='UNFORMATTED')
        READ(1)NATOM,NSORT,NSPIN,NORBS,(IS(IATOM),IATOM=1,NATOM),
     &  (ILSB(ISORT),ISORT=1,NSORT),(NHSORT(ISORT),ISORT=1,NSORT),
     &  NKAP,NBNDF,NBNDE,NBNDT,NPNT,NDIR,NDIV,EF
        READ(1)(TXTEL(ISORT),ISORT=1,NSORT),
     &  ((PNTNOT(INOT,IDIR),INOT=1,2),IDIR=1,NDIR)
	LMB=0 
        DO ISORT=1,NSORT
        IF(ISORT.LE.9)WRITE(TLAB(ISORT),FMT='(I1)')ISORT
        IF(ISORT.GT.9)WRITE(TLAB(ISORT),FMT='(I2)')ISORT
	IF(ISORT.GT.99)STOP' ISORT > 99 NOT ASSUMED'
	LMB=MAX(ILSB(ISORT),LMB)
	ENDDO
	WRITE(2)NATOM,NSORT,LMB+1
	WRITE(2)(NHSORT(ISORT),ISORT=1,NSORT),
     &  (TLAB(ISORT),ISORT=1,NSORT)
C SET NDIM
	NDIM=NATOM*(LMB+1)**2
C START LOOPING OVER K-POINTS, BANDS
	DO 2000 IPNT=1,NPNT
	READ(1)(PNT(I,IPNT),I=1,3),(EARR(IBAND,IPNT),IBAND=1,NBNDT*NSPIN)
	DO 1000 IBND=1,NBNDF
        READ(1)(((TLMC(LM,IATOM,IORBS),
     &  LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IORBS=1,NORBS)
C SUM OVER SPINS
	IDIM=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,LMB
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=IDIM+1
	TLM(LM,IATOM)=0.D0
	DO IORBS=1,NORBS
	IF(L.LE.ILSB(ISORT))
     &  TLM(LM,IATOM)=TLM(LM,IATOM)+TLMC(LM,IATOM,IORBS)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C REORDER TLM FOR TB-PLOTTING ROUTINE
C P-WAVE IS
	DO IATOM=1,NATOM
	TX=TLM(2,IATOM)
	TY=TLM(3,IATOM)
	TZ=TLM(4,IATOM)
	TLM(2,IATOM)=TY
	TLM(3,IATOM)=TY
	TLM(4,IATOM)=TZ
C D-WAVE
	TYZ=TLM(5,IATOM)
	TZX=TLM(6,IATOM)
	TXY=TLM(7,IATOM)
	TX2=TLM(8,IATOM)
	TZ2=TLM(9,IATOM)
	TLM(5,IATOM)=TXY
	TLM(6,IATOM)=TYZ
	TLM(7,IATOM)=TZ2
	TLM(8,IATOM)=TZX
	TLM(9,IATOM)=TX2
C F-WAVE NOT READY
	ENDDO
C PREPARE TVEC
	IDIM=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO LM=1,(LMB+1)**2
	IDIM=IDIM+1
	TVEC(IDIM,IBND)=CMPLX(SQRT(TLM(LM,IATOM)),0.0)
	DO IBNDU=NBNDF+1,NDIM
	TVEC(IDIM,IBNDU)=(0.0,0.0)
	ENDDO
	ENDDO
	ENDDO
1000	CONTINUE
	DO IBND=1,MIN(NDIM,NBNDT)
	ERL(IBND)=EARR(IBND,IPNT)
	ENDDO
	DO IBND=MIN(NBNDT,NDIM)+1,NDIM
	ERL(IBND)=EARR(MIN(NBNDT,NDIM),IPNT)
	ENDDO
C STORE WITH THE SINGLE PRECISION:
 	WRITE(2)(ERL(IBND),IBND=1,NDIM),
     &  ((REAL(TVEC(IDIM,IBND)),IDIM=1,NDIM),IBND=1,NDIM),
     &  ((IMAG(TVEC(IDIM,IBND)),IDIM=1,NDIM),IBND=1,NDIM)
2000	CONTINUE
	CLOSE(1)
	CLOSE(2)
C WRITE BNDS:
	OPEN(UNIT=3,FILE='BNDS',STATUS='NEW',ACCESS='SEQUENTIAL',
     &  FORM='FORMATTED')
	WRITE(3,1030)NDIM,EF,1.D0,NSPIN
C DO OVER DIRECTIONS
	DO IDIR=1,NDIR
	WRITE(3,1040)NDIV+1,(PNTNOT(INOT,IDIR),INOT=1,2)
	DO IDIV=1,NDIV+1
	IPNT=IDIV+(NDIV+1)*(IDIR-1) 
C SET TO REAL
	DO IBND=1,MIN(NDIM,NBNDT)
	ERL(IBND)=EARR(IBND,IPNT)
	ENDDO
	DO IBND=MIN(NBNDT,NDIM)+1,NDIM
	ERL(IBND)=EARR(MIN(NBNDT,NDIM),IPNT)
	ENDDO
C STORE BANDS
	WRITE(3,1050)(PNT(I,IPNT),I=1,3),(ERL(IBND),IBND=1,NDIM)
	ENDDO
	ENDDO
	WRITE(3,1040)0,'X','X'
	CLOSE(3)
1010    FORMAT(1X,'FATFILE? ',$)
1020    FORMAT(A)
1030	FORMAT(I5,2F10.5,I5)
1040	FORMAT(I5,1X,A1,1X,A1)
1050	FORMAT(3F10.5/(10F8.4))
	END
