*************************************************************************
* The program plots a set of energy bands in a number of directions.    *
* Written by S.Yu.Savrasov in Max-Planck-Institute, Germany. Nov.1992.  *
*************************************************************************
C SET PARAMETERS OF THE ARRAYS AND THEIR MEANING
	PARAMETER (KMAX=200)   ! max.number of k-points for one direction
	PARAMETER (JMAX=500)   ! max.number of energy bands in one point
	PARAMETER (NDIRMAX=20) ! max.number of high-symmetry directions
	PARAMETER (NPLTMAX=50) ! max.number of bnd-data to be drawn
C DECLARE ARRAYS 
	CHARACTER PNTNOT(2,NDIRMAX)*1,STRFILE*60,BNDFILE(NPLTMAX)*60
     &    ,PNTSYM(NDIRMAX+1,NDIRMAX)*1,TITLE*40,PLTFILE*40,STATUS*20
	DIMENSION ABSL(NDIRMAX,NDIRMAX),XREG(NDIRMAX,NDIRMAX)
     &    ,E0(KMAX,JMAX),X0(KMAX),DASH(4,NPLTMAX),SD(4,2:5)
	INTEGER NDIRW(NDIRMAX),ISOLID(NPLTMAX),IPEN(NPLTMAX)
	LOGICAL P1,P2,P3,P4,EXIST
C INTERFACE WITH THE GRAFOR-PACKAGE
	COMMON /STATUS/ PLTFILE,STATUS
C SPECIFY DEFAULT PLOT SIZE DATA IN SM, WHOLE PLOT CAN BE SCALED BY PLOT.EXE!
	DATA REGX /3.0/          ! MAX.SIZE OF REGION ALONG X
	DATA REGY /8.0/          ! FIX.SIZE OF REGION ALONG Y
	DATA DWINX /2.0/         ! DISTANCE BETWEEN WINDOWS AND MARGINS ALONG X
	DATA DWINY /1.5/         ! DISTANCE BETWEEN WINDOWS AND MARGINS ALONG Y
	DATA LPEN /2/            ! PEN FOR MARGINS AND LABELS
C SPECIFY DASHED LINE CHOICES
	DATA (SD(I,2),I=1,4)/0.025,0.075,0.025,0.075/ ! DOTTED LINE
	DATA (SD(I,3),I=1,4)/0.100,0.100,0.100,0.100/ ! DASHED LINE
	DATA (SD(I,4),I=1,4)/0.300,0.100,0.300,0.100/ ! LONG-DASHED 
	DATA (SD(I,5),I=1,4)/0.200,0.100,0.025,0.100/ ! DOTTED-DASH
C PRINT TITLE OF THE PROGRAM
	PRINT*,'***************************************************'
	PRINT*,'* The program makes PLOT.PLT file with the energy *'
	PRINT*,'* band curves to be plotted in terms of the VIEW/ *'
	PRINT*,'* PLOT.EXE utilities of the GRAPHER-package.  The *'
	PRINT*,'* input files must be specified  as those used in *'
	PRINT*,'* the  FP-LMTO program of Savrasov  and Savrasov. *'
	PRINT*,'* Russian  GRAFOR-library is  used for generating *'
	PRINT*,'* the picture.       Version 2.04, November 1996. *'
	PRINT*,'***************************************************'
C GET FILE NAMES WITH THE DATA
	PRINT10
   10   FORMAT(1X,'# of files to plot? ',$)
	READ(5,*)NFILE
	DO 25 IFILE=1,NFILE
	PRINT15
	READ(5,20)BNDFILE(IFILE)
  15    FORMAT(1X,'Enter BNDFILE name: ',$)
  20    FORMAT(A)
  25    CONTINUE
	PRINT26
  26    FORMAT(1X,'Enter STRFILE name: ',$)
	READ(5,20)STRFILE
C READ BAND STRUCTURE AND STORE IT IN A SCRATCH FILE
	CALL GETBND(NFILE,BNDFILE,NPLOT,NPNT,NDIV,NBND,EMIN,EMAX,EF)
C READ DIRECTION DATA FROM STRFILE
	CALL GETDIR(STRFILE,PNTNOT,PNTSYM,NWIN,NDIRW,NDIR,ABSL,AM)
C PRINT PLOT DATA
	PRINT*,'***************************************************'
	PRINT27,NPLOT,EF
  27    FORMAT(1X,'# of band pictures to plot=',
     &  I2,'; Fermi level=',G14.7)
	PRINT28,EMIN,EMAX
  28    FORMAT(1X,'Minimum energy=',G14.7,', Maximum energy=',G14.7)
	PRINT29
  29    FORMAT(1X,'Type own limits: ',$)
	READ(5,*)EMIN,EMAX
	PRINT*,'Now you must specify how to plot the energy bands.'
	PRINT*,'The standard line choices are'
	PRINT*,'    LINE:           CODE:'
	PRINT*,'    full              1   '
	PRINT*,'    dotted            2   '
	PRINT*,'    dashed            3   '
	PRINT*,'    long-dashed       4   '
	PRINT*,'    dotted-dashed     5   '
	PRINT*,'    own choice        6   '
	DO 37 IPLOT=1,NPLOT
	PRINT33,IPLOT
  33    FORMAT(1X, 'Enter line code and pen # for picture ',I2,' :')
  34    READ(5,*)ISOLID(IPLOT),IPEN(IPLOT)
	IF(ISOLID(IPLOT).GT.6.OR.ISOLID(IPLOT).LT.1)THEN
	PRINT*,'PLEASE ENTER LINE CODE AND PEN #'
	GOTO34
	ELSEIF(ISOLID(IPLOT).EQ.6)THEN
	PRINT35,'Enter your own lenghts of dashes (4 digits) in sm : '
  35    FORMAT(1X,A)
	READ(5,*)DASH(1,IPLOT),DASH(2,IPLOT),DASH(3,IPLOT),DASH(4,IPLOT)
	ELSEIF(ISOLID(IPLOT).GT.1.AND.ISOLID(IPLOT).LT.6)THEN
	DO 36 ID=1,4
	DASH(ID,IPLOT)=SD(ID,ISOLID(IPLOT))
  36    CONTINUE
	ENDIF
  37    CONTINUE
	PRINT*,'Type plot TITLE by capital letters, (enter if none)'
	READ(5,38)TITLE
	ITITLE=1
	IF(TITLE(1:1).EQ.' ')ITITLE=0
  38    FORMAT(A40)
C SET OUTPUT FILE NAME
	PRINT*,'***************************************************'
	PRINT*,'The program will  now create  PLOT.PLT file in the '
	PRINT*,'OVERWRITE mode. If you agree with that press ENTER,'
	PRINT*,'if not, type a new filename.                       '
	READ(5,38)PLTFILE
	IF(PLTFILE(1:1).EQ.' ')PLTFILE='plot.plt'
	INQUIRE(FILE=PLTFILE,EXIST=EXIST)
	IF(EXIST)THEN
	OPEN(3,FILE=PLTFILE,STATUS='OLD')
	CLOSE(3,STATUS='DELETE')
	ENDIF
	STATUS='NEW'         
	PRINT*,'***************************************************'
C CALCULATE REGION SIZES AND ESTIMATE TOTAL PAGE SIZE
	XPAGE=0.D0
	DO 50 IWIN=1,NWIN
	XPAGE=XPAGE+DWINX
	DO 40 IDIRW=1,NDIRW(IWIN)
	XREG(IDIRW,IWIN)=ABSL(IDIRW,IWIN)/AM*REGX
	XPAGE=XPAGE+XREG(IDIRW,IWIN)
  40    CONTINUE
  50    CONTINUE
	YREG=REGY
	XPAGE=XPAGE+DWINX
	YPAGE=DWINY+REGY+DWINY
	XSCALEL=27.0/XPAGE
	YSCALEL=18.0/YPAGE
	XSCALEP=18.0/XPAGE
	YSCALEP=27.0/YPAGE
	PRINT60,XPAGE,XSCALEL,XSCALEP
	PRINT70,YPAGE,YSCALEL,YSCALEP
	PRINT75
	PRINT76
	PRINT77
  60    FORMAT(1X,'X-Page(sm)=',G10.3,
     & '; X-scale for A4 landscape/portrait=',G10.3,'/',G10.3)
  70    FORMAT(1X,'Y-Page(sm)=',G10.3,
     & '; Y-scale for A4 landscape/portrait=',G10.3,'/',G10.3)
  75    FORMAT(1X,
     & 'Be sure that the paper size is properly  installed. Use plot/i')
  76    FORMAT(1X,
     & 'option 4 to check out the paper size for A4 format. Use plot/i')
  77    FORMAT(1X,
     & 'option 6 to plot in landscape/portrait mode.')
C SET UP PAGE BY GRAFFOR-LIBRARY
	CALL GRAFOR('PL')
	CALL PEN(LPEN)
	CALL PAGE(XPAGE,YPAGE,' ',1,0)
C *** DO GLOBALLY OVER WINDOWS ***
	DO 160 IWIN=1,NWIN                        !!! over windows
	XCOORD=XCOORD+DWINX
	XEFLIN=XCOORD
	YCOORD=DWINY
C *** DO GLOBALLY OVER DIRECTIONS ***
	DO 150 IDIRW=1,NDIRW(IWIN)                !!! over directions
C SET UP REGION FOR ONE DIRECTION
	CALL REGION(XCOORD,YCOORD,XREG(IDIRW,IWIN),YREG,' ',1,1)
	CALL LIMITS(0.0,1.0,EMIN,EMAX)
C FIND END POINTS OF THE DIRECTION SPECIFIED
	DO 80 IDIR=1,NDIR
	P1=PNTNOT(1,IDIR).EQ.PNTSYM(IDIRW,IWIN)
	P2=PNTNOT(2,IDIR).EQ.PNTSYM(IDIRW+1,IWIN)
	IF(P1.AND.P2) GOTO 90
	P3=PNTNOT(2,IDIR).EQ.PNTSYM(IDIRW,IWIN)
	P4=PNTNOT(1,IDIR).EQ.PNTSYM(IDIRW+1,IWIN)
	IF(P3.AND.P4) GOTO 90
  80    CONTINUE
	STOP'ERROR IN SEARCH FOR DIRECTION,CHECK <STRFILE>'
  90    NPNTL=1+(NDIV+1)*(IDIR-1)              !!! lower k-point
	NPNTU=NPNTL+NDIV                       !!! upper k-point
C *** DO GLOBALLY OVER DIFFFERENT BNDFILES ***
	DO 140 IPLOT=1,NPLOT                   !!! over plots
	IF(ISOLID(IPLOT).EQ.1)CALL FULL
	IF(ISOLID(IPLOT).NE.1)CALL BROKEN(DASH(1,IPLOT),DASH(2,IPLOT),
     &  DASH(3,IPLOT),DASH(4,IPLOT))
C GET ENERGY BANDS FROM THE FILE
	IF(P1.AND.P2)THEN
	K=0
	DO 100 IPNT=NPNTL,NPNTU
	K=K+1
	IREC=IPNT+NPNT*(IPLOT-1)
	READ(2,REC=IREC)(E0(K,IBND),IBND=1,NBND)
	X0(K)=FLOAT(K-1)/NDIV
 100    CONTINUE
	ELSEIF(P3.AND.P4)THEN
	K=NDIV+2
	DO 110 IPNT=NPNTL,NPNTU
	K=K-1
	IREC=IPNT+NPNT*(IPLOT-1)
	READ(2,REC=IREC)(E0(K,IBND),IBND=1,NBND)
	X0(K)=FLOAT(K-1)/NDIV
 110    CONTINUE
	ENDIF
C FIND MINIMUM AND MAXIMUM VALUES
	CALL PEN(IPEN(IPLOT))
	DO 130 IBND=1,NBND
	E0MIN=E0(1,IBND)
	E0MAX=E0(1,IBND)
	DO 120 K=1,NDIV+1
	E0MIN=MIN(E0MIN,E0(K,IBND))
	E0MAX=MAX(E0MAX,E0(K,IBND))
 120    CONTINUE
	IF(E0MAX.LT.EMIN.OR.E0MIN.GT.EMAX)GOTO130
C PLOT ENERGY BANDS BY GRAFOR-LIBRARY
	IF(ISOLID(IPLOT).EQ.1)
     &  CALL LINEO(X0(1),E0(1,IBND),NDIV+1)
	IF(ISOLID(IPLOT).NE.1)
     &  CALL BRLINE(X0(1),E0(1,IBND),NDIV+1)
 130    CONTINUE                             !!! over energy bands
 140    CONTINUE                             !!! over different bndfiles
C SPECIFY Y-AXE FOR THE FIRST DIRECTION
	CALL PEN(LPEN)
	DIF=EMAX-EMIN 
	IF(DIF.GT.0.00)SRY=DIF/5.0
	IF(DIF.GT.0.02)SRY=0.02
	IF(DIF.GT.0.10)SRY=0.10
	IF(DIF.GT.0.80)SRY=0.20
	IF(DIF.GT.2.00)SRY=0.50
	IF(DIF.GT.6.0)SRY=DIF/5.0
	IF(IDIRW.EQ.1)
     &  CALL YAXIS(0.0,'ENERGY,RY',9,SRY,2,0,1)
C SPECIFY Y-AXE FOR THE LAST DIRECTION
	IF(IDIRW.EQ.NDIRW(IWIN))THEN
	DEV=(EMAX-EMIN)*13.6
	IF(DEV.GT.0.00)SEV=DEV/5.
	IF(DEV.GT.0.20)SEV=0.20
	IF(DEV.GT.1.00)SEV=1.00
	IF(DEV.GT.8.00)SEV=2.00
	IF(DEV.GT.20.0)SEV=5.00
	IF(DEV.GT.60.0)SEV=DEV/5.
	CALL LIMITS(0.0,1.0,EMIN*13.6,EMAX*13.6)
	CALL YAXIS(1.0,'ENERGY,EV',9,SEV,2,0,-2)
	ENDIF
C PLOT LABELS OF THE DIRECTION
	XSYM=XCOORD-0.15
	YSYM=YCOORD-1.0
	CALL SYMBOL(XSYM,YSYM,0.7,PNTSYM(IDIRW,IWIN),1,0.0)
	IF(IDIRW.EQ.NDIRW(IWIN))THEN
	XSYM=XCOORD+XREG(IDIRW,IWIN)-0.15
	YSYM=YCOORD-1.0
	CALL SYMBOL(XSYM,YSYM,0.7,PNTSYM(IDIRW+1,IWIN),1,0.0)
	ENDIF
C MOVE X-COORDINATE OF THE REGION
	XCOORD=XCOORD+XREG(IDIRW,IWIN)
 150    CONTINUE                             !!! over directions
C PLOT FERMI LINE
	IF(EF.LE.EMAX.AND.EF.GE.EMIN)THEN
	YEF=DWINY+(EF-EMIN)/(EMAX-EMIN)*REGY
	XEF1=XEFLIN
	XEF2=XCOORD
	CALL MOVE(XEF1,YEF,0)
	CALL DASHP(XEF2,YEF,0.5)             !!! plot by dashed line
	XSYM=XEF1+0.1
	YSYM=YEF +0.1
	CALL SYMBOL(XSYM,YSYM,0.3,'EF',2,0.0)
	ENDIF
 160    CONTINUE                             !!! over windows
	CLOSE(2,STATUS='DELETE')
C PLOT TITLE
	IF(ITITLE.EQ.1)THEN
	XSYM=DWINX
	YSYM=YPAGE-DWINY+0.5
	CALL SYMBOL(XSYM,YSYM,0.5,TITLE,40,0.0)
	ENDIF
C END OF PLOT
	CALL ENDPG('END')
C       PRINT*,'Normal successfull completion.'
	STOP
	END




	SUBROUTINE GETDIR(STRFILE,PNTNOT,PNTSYM,NWIN,NDIRW,NDIR,ABSL,AM)
***********************************************************************
*  Read strfile specified above and return symmetry-point information.*
***********************************************************************
C SET PARAMETERS OF THE ARRAYS AND THEIR MEANING
	PARAMETER (KMAX=200)  ! max.number of k-points for one direction
	PARAMETER (JMAX=500)  ! max.number of energy bands in one point
	PARAMETER (NDIRMAX=20)! max.number of high-symmetry directions
	PARAMETER (NPLTMAX=50)! max.number of bnd-data to be drawn
C DECLARE ARRAYS
	CHARACTER PNTNOT(2,NDIRMAX)*1,DLINE(72)*1,STRFILE*60
     &    ,PNTSYM(NDIRMAX+1,NDIRMAX)*1,STRING(80)*1
	REAL*8    HSPNT(3,2,NDIRMAX)
	DIMENSION ABSL(NDIRMAX,NDIRMAX),ORTH(2:3)
	INTEGER NDIRW(NDIRMAX)
	LOGICAL P1,P2,P3,P4
C READ DATA FROM THE STRFILE
	OPEN(1,FILE=STRFILE,STATUS='OLD',FORM='FORMATTED') 
	DO 10 I=1,3           ! skip 3 lines
	READ(1,*)
  10    CONTINUE
	READ(1,*)NATOM,ORTH
        READ(1,*)IBAS,IBZ,ICALC,ISTRAIN
	DO 20 I=1,2*NATOM+19  ! skip more
  20    READ(1,*)
	CONTINUE
        READ(1,*)NDIR                             !!! # of h.s. directions
	IF(NDIR.GT.NDIRMAX)STOP'# OF DIRECTIONS IS TOO LARGE,
     &  INCREASE NDIRMAX THROUGHOUT THE PROGRAM'
        DO 30 IDIR=1,NDIR
        READ(1,40)(PNTNOT(IVEC,IDIR),IVEC=1,2)
        IF(ICALC.NE.1)THEN
        READ(1,*)((HSPNT(I,IVEC,IDIR),I=1,3),IVEC=1,2) ! high-symmetry dirs
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,45)STRING
        CALL COMPVEC(STRING,HSPNT(1,1,IDIR),6)
        ENDIF
	DO 25 IYZ=2,3
	HSPNT(IYZ,1,IDIR)=HSPNT(IYZ,1,IDIR)/ORTH(IYZ)
	HSPNT(IYZ,2,IDIR)=HSPNT(IYZ,2,IDIR)/ORTH(IYZ)
  25	CONTINUE	
  30    CONTINUE
  40    FORMAT(2(1X,A1)) 
  45    FORMAT(80A1)
	READ(1,*)
	READ(1,FMT=50,END=60,ERR=60)(DLINE(I),I=1,72)
  50    FORMAT(72A1)
  60    CLOSE(1)
C GET LIMITS
	IMIN=1
	IMAX=1
	DO 70 I=1,72
	IF(DLINE(I).EQ.' ')IMIN=I+1
	IF(DLINE(I).EQ.'.')IMAX=I-1
	IF(DLINE(I).EQ.'.')GOTO80
  70    CONTINUE
  80    IF(IMIN.GT.IMAX.OR.IMAX.EQ.1)STOP'COMMAND  LINE ERROR,
     &  CHECK COMMAS AND DOT AT THE END. I.E:  G-X-L-M,N-M-L.'
C DEFINE # OF WINDOWS
	NWIN=1
	NDIRW(1)=0
	DO 90 I=IMIN,IMAX       
	IF(DLINE(I).EQ.',')NWIN=NWIN+1
	IF(DLINE(I).EQ.',')NDIRW(NWIN)=0
	IF(DLINE(I).EQ.'-')NDIRW(NWIN)=NDIRW(NWIN)+1
  90    CONTINUE
C SET SYMBOLS OF DIRECTIONS
	NSHIFT=0
	DO 110 IWIN=1,NWIN
	DO 100 IDIRW=1,NDIRW(IWIN)
	I=IMIN+NSHIFT
	PNTSYM(IDIRW,IWIN)=DLINE(I)
	NSHIFT=NSHIFT+2
 100    CONTINUE
	I=IMIN+NSHIFT
	PNTSYM(NDIRW(IWIN)+1,IWIN)=DLINE(I)
	NSHIFT=NSHIFT+2
 110    CONTINUE
C SET LENGHTS OF DIRECTIONS
	AM=0.0
	DO 160 IWIN=1,NWIN
	DO 150 IDIRW=1,NDIRW(IWIN)
	DO 120 IDIR=1,NDIR
	P1=PNTNOT(1,IDIR).EQ.PNTSYM(IDIRW,IWIN) 
	P2=PNTNOT(2,IDIR).EQ.PNTSYM(IDIRW+1,IWIN) 
	IF(P1.AND.P2) GOTO 130
	P3=PNTNOT(2,IDIR).EQ.PNTSYM(IDIRW,IWIN) 
	P4=PNTNOT(1,IDIR).EQ.PNTSYM(IDIRW+1,IWIN) 
	IF(P3.AND.P4) GOTO 130
 120    CONTINUE
	STOP'ERROR IN SEARCH FOR DIRECTION,CHECK <STRFILE>'
 130    ABS=0.D0
	DO 140 I=1,3
	ABS=ABS+(HSPNT(I,1,IDIR)-HSPNT(I,2,IDIR))**2
 140    CONTINUE
	ABSL(IDIRW,IWIN)=SQRT(ABS)
	AM=MAX(AM,ABSL(IDIRW,IWIN))
 150    CONTINUE
 160    CONTINUE 
	END



	SUBROUTINE GETBND(NFILE,BNDFILE,NPLOT,NPNT,NDIV,NBND,
     &  EMIN,EMAX,EF)
*********************************************************************
*  Read energy bands from BNDFILE and store them in a scratch file. *
*********************************************************************
C  SET PARAMETERS OF THE ARRAYS
	PARAMETER (KMAX=200)   ! max.number of k-points for one direction
	PARAMETER (JMAX=500)   ! max.number of energy bands in one point
	PARAMETER (NDIRMAX=20) ! max.number of high-symmetry directions
	PARAMETER (NPLTMAX=50) ! max.number of bnd-data to be drawn
C DECLARE ARRAYS 
	CHARACTER BNDFILE(NPLTMAX)*60
	DIMENSION EARR(JMAX),ER(2*JMAX)
	LOGICAL FIRST
	DATA FIRST/.TRUE./
C *** DO GLOBALLY OVER BNDFILES ***
	NPLOT=0
	DO 60 IFILE=1,NFILE
	OPEN(1,FILE=BNDFILE(IFILE),STATUS='OLD',FORM='FORMATTED')
	IF(NPLOT.EQ.0)THEN
	READ(1,*)NATOM,EF,NPNT,NDIV,NBND,NSPIN
C  OPEN SCRATCH FILE FOR STORING ENERGY BANDS
	OPEN(2,STATUS='SCRATCH',FORM='UNFORMATTED',ACCESS='DIRECT',
     &  RECL=4*NBND)
	DELTA=0.0       
	ELSEIF(NPLOT.NE.0)THEN
	READ(1,*)NAT00,E0,NPN0,NDI0,NBN0,NSPIN
C  CHECK INPUT DATA
	IF(NPN0.NE.NPNT)STOP'DIFFERENT # OF POINTS IN BNDFILES IS NOT
     &  ALLOWED'
	IF(NDI0.NE.NDIV)STOP'DIFFERENT # OF DIVISIONS IN BNDFILES IS NOT
     &  ALLOWED'
	IF(NBN0.NE.NBND)STOP'DIFFERENT # IF BANDS IN BNDFILES IS NOT
     &  ALOWED'
	DELTA=EF-E0
	IF(ABS(DELTA).GE.1.D-04)PRINT*,'DIFFERENT FFERMI LEVEL FOUND;
     &  WHOLE BAND STRUCTURE WILL BE SHIFTED TO ',DELTA
	ENDIF
C  READ ENERGY BANDS AND STORE THEM IN A SCRATCH FILE
	IF(NSPIN.EQ.2)THEN
	NB=INDEX(BNDFILE(IFILE),' ')
	PRINT*
	PRINT*,'Spin-polarized bands found in ',BNDFILE(IFILE)(:NB-1)
	PRINT20
  10    READ(5,*)ISPINP
  20    FORMAT(1X,'Plot both spins(0) or up(1)/dn(2) spins ? ',$)
	IF(ISPINP.NE.0.AND.ISPINP.NE.1.AND.ISPINP.NE.2)THEN
	PRINT*,'PLEASE ANSWER: 0,1 OR 2'
	GOTO10
	ENDIF
	ELSEIF(NSPIN.EQ.1)THEN
	ISPINP=1
	ENDIF
	DO 50 IPNT=1,NPNT
	READ(1,*)PNTX,PNTY,PNTZ
	READ(1,*)((ER(ISPIN+NSPIN*(IBND-1)),ISPIN=1,NSPIN),IBND=1,NBND)
	DO 40 ISPIN=1,NSPIN
	DO 25 IBND=1,NBND
	EARR(IBND)=ER(ISPIN+NSPIN*(IBND-1)) 
  25	CONTINUE
	IF(ISPINP.NE.0.AND.ISPINP.NE.ISPIN)GOTO40
C  FIND MINIMUM AND MAXIMUM VALUES
	IF(FIRST)THEN
	EMIN=EARR(1)
	EMAX=EARR(1)
	FIRST=.FALSE.
	ENDIF
	NPLOT=NPLOT+1
	DO 30 IBND=1,NBND
	EMIN=MIN(EMIN,EARR(IBND)+DELTA)
	EMAX=MAX(EMAX,EARR(IBND)+DELTA)
  30    CONTINUE
	IREC=IPNT+NPNT*(NPLOT-1)
	WRITE(2,REC=IREC)(EARR(IBND)+DELTA,IBND=1,NBND)
  40    CONTINUE
	IF(ISPINP.EQ.0)NPLOT=NPLOT-2
	IF(ISPINP.NE.0)NPLOT=NPLOT-1
  50    CONTINUE
	IF(ISPINP.EQ.0)NPLOT=NPLOT+2
	IF(ISPINP.NE.0)NPLOT=NPLOT+1
	CLOSE(1)
  60    CONTINUE
	END
