***********************************************************
*  The program plots a set of projected state densities.  *
*  Written by S.Yu.Savrasov in Max-Planck-Institut, FRG.  *
***********************************************************
C SET PARAMETERS OF ARRAYS AND THEIR MEANING
	PARAMETER (NWINMAX=20)   ! MAX.NUMBER OF WINDOWS
	PARAMETER (NPLTMAX=20)   ! MAX.NUMBER OF PLOTS IN ONE WINDOW
	PARAMETER (LMAXMAX=8)    ! MAX.LMAX
	PARAMETER (NDOSMAX=10000)! MAX.NUMBER OF ENERGY POINTS
	PARAMETER (NSORTMAX=100) ! MAX.NUMBER OF ATOMS OF DIFFERENT TYPE
	PARAMETER (NKAPMAX=5)    ! MAX.NUMBER OF KAPPA
	PARAMETER (NSPINMAX=2)   ! MAX.NUMBER OF SPINS
C DECLARE ARRAYS
	INTEGER ISOLID(NPLTMAX,NWINMAX),IPEN(NPLTMAX,NWINMAX)
     &    ,NPLT(NWINMAX),IWINTIT(NWINMAX)
	DIMENSION E(0:NDOSMAX),DOS(0:NDOSMAX),DOSMAX(NWINMAX)
     &    ,YREG(NWINMAX),DASH(4,NPLTMAX,NWINMAX)
	CHARACTER DOSFILE*60,WINTIT(NWINMAX)*40,TITLE*40
     &    ,PLTFILE*40,STATUS*20
	LOGICAL EXIST
C INTERFACE WITH GRAFOR-PACKAGE
	COMMON /STATUS/ PLTFILE,STATUS
C SET DEFAULT PLOT-SIZE DATA, WHOLE PLOT MAY BE SCALED BY PLOT.EXE
	DATA REGX/14.0/ ! SIZE OF REGION (WINDOW) ALONG X
	DATA REGY/8.00/ ! MAX.SIZE OF REGION ALONG Y
	DATA REGM/1.00/ ! MIN.SIZE OF REGION ALONG Y
	DATA DWINX/1.5/ ! DISTANCE BETWEEN WINDOWS AND MARGINS ALONG X
	DATA DWINY/1.5/ ! DISTANCE BETWEEN WINDOWS AND MARGINS ALONG Y
	DATA LPEN/2/    ! PEN FOR MARGINS, LABELS, SYMBLOS, ETC.
C PRINT TITLE OF THE PROGRAM
	PRINT*,'***************************************************'
	PRINT*,'* The program makes PLOT.PLT file with the density*'
	PRINT*,'* of states  to be plotted in terms of  the VIEW/ *'
	PRINT*,'* PLOT.EXE utilities of the GRAPHER-package.  The *'
	PRINT*,'* input file must be  specified  as that  used in *'
	PRINT*,'* the  FP-LMTO program of Savrasov  and Savrasov. *'
	PRINT*,'* Russian  GRAFOR-library is  used for generating *'
	PRINT*,'* the picture.       Version 2.04, November 1996. *'
	PRINT*,'***************************************************'
C GET FILE NAME WITH THE DATA
	PRINT10
	READ(5,20)DOSFILE
  10    FORMAT(1X,'Enter DOSFILE name: ',$)
  20    FORMAT(A)
	CALL GETDOS(DOSFILE,NWIN,NPLT,ISOLID,IPEN,DASH,IWINTIT,WINTIT,
     &  ITITLE,TITLE,IPROP,DOSMAX,DM,E,EMIN,EMAX,EF,NPNT)
C SET OUTPUT FILE NAME
	PRINT*,'***************************************************'
	PRINT*,'The program will  now create  PLOT.PLT file in the '
	PRINT*,'OVERWRITE mode. If you agree with that press ENTER,'
	PRINT*,'if not, type a new filename.                       '
	READ(5,30)PLTFILE
  30    FORMAT(A40)
        IF(PLTFILE(1:1).EQ.' ')PLTFILE='plot.plt'
        INQUIRE(FILE=PLTFILE,EXIST=EXIST)
        IF(EXIST)THEN
        OPEN(3,FILE=PLTFILE,STATUS='OLD')
        CLOSE(3,STATUS='DELETE')
        ENDIF
        STATUS='NEW'
	PRINT*,'***************************************************'
C CALCULATE REGION SIZES AND ESTIMATE TOTAL PAGE SIZE
	XREG=REGX
	XPAGE=DWINX+REGX+DWINX
	YPAGE=DWINY
	NREC=0
	DO 40 IWIN=1,NWIN
	IF(IPROP.EQ.0)YREG(IWIN)=REGY
	IF(IPROP.EQ.1)YREG(IWIN)=DOSMAX(IWIN)/DM*REGY
	IF(YREG(IWIN).LT.REGM)YREG(IWIN)=REGM
	IF(YREG(IWIN).LT.REGM)DOSMAX(IWIN)=YREG(IWIN)/REGY*DM
	YPAGE=YPAGE+YREG(IWIN)
	DO 40 IPLT=1,NPLT(IWIN)
	NREC=NREC+1
  40    CONTINUE
	YPAGE=YPAGE+DWINY
	XSCALEL=27.0/XPAGE
	YSCALEL=18.0/YPAGE
	XSCALEP=18.0/XPAGE
	YSCALEP=27.0/YPAGE
	PRINT60,XPAGE,XSCALEL,XSCALEP
	PRINT70,YPAGE,YSCALEL,YSCALEP
	PRINT75
	PRINT76
	PRINT77
  60    FORMAT(1X,'X-Page(sm)=',G10.3,
     & '; X-scale for A4 landscape/portrait=',G10.3,'/',G10.3)
  70    FORMAT(1X,'Y-Page(sm)=',G10.3,
     & '; Y-scale for A4 landscape/portrait=',G10.3,'/',G10.3)
  75    FORMAT(1X,
     & 'Be sure that the paper size is properly  installed. Use plot/i')
  76    FORMAT(1X,
     & 'option 4 to check out the paper size for A4 format. Use plot/i')
  77    FORMAT(1X,
     & 'option 6 to plot in landscape/portrait mode.')
C SET UP PAGE BY GRAFFOR-LIBRARY
	CALL GRAFOR('PL')
	CALL PEN(LPEN)
	CALL PAGE(XPAGE,YPAGE,' ',1,0)
C *** DO GLOBALLY OVER WINDOWS ***
	IREC=NREC
	XCOORD=DWINX
	YCOORD=DWINY
	DO 90 IWIN=NWIN,1,-1                       !!! over windows
	CALL REGION(XCOORD,YCOORD,XREG,YREG(IWIN),' ',1,1)
	CALL LIMITS(EMIN,EMAX,0.0,DOSMAX(IWIN))
	DO 80 IPLT=NPLT(IWIN),1,-1                 !!! over plots
	IF(ISOLID(IPLT,IWIN).EQ.1)CALL FULL
	IF(ISOLID(IPLT,IWIN).NE.1)CALL BROKEN(DASH(1,IPLT,IWIN),
     &  DASH(2,IPLT,IWIN),DASH(3,IPLT,IWIN),DASH(4,IPLT,IWIN))
	READ(2,REC=IREC)(DOS(I),I=0,NPNT)
	IREC=IREC-1
	CALL PEN(IPEN(IPLT,IWIN))
C PLOT DENSITY OF STATES BY GRAFOR-LIBRARY
	IF(ISOLID(IPLT,IWIN).EQ.1)
     &  CALL LINEO(E(0),DOS(0),NPNT+1)
	IF(ISOLID(IPLT,IWIN).NE.1)
     &  CALL BRLINE(E(0),DOS(0),NPNT+1)
  80    CONTINUE                                   !!! over plots
C PLOT AXES
	CALL PEN(LPEN)
	IF(IWIN.EQ.NWIN)THEN
	DIF=EMAX-EMIN
	IF(DIF.GT.0.00)SRY=DIF/5.0
	IF(DIF.GT.0.02)SRY=0.02
	IF(DIF.GT.0.10)SRY=0.10
	IF(DIF.GT.0.80)SRY=0.20
	IF(DIF.GT.2.00)SRY=0.50
	IF(DIF.GT.6.0)SRY=DIF/5.0
	CALL XAXIS(0.0,'ENERGY,RY',9,SRY,2,0,1) 
	ENDIF
	DMAX=DOSMAX(IWIN)
	IF(DMAX.GT.0.0)SDS=DMAX/5.0
	IF(DMAX.GT.0.2)SDS=0.2
	IF(DMAX.GT.1.0)SDS=1.0
	IF(DMAX.GT.5.0)SDS=2.0
	IF(DMAX.GT.15.0)SDS=5.0
	IF(DMAX.GT.40.0)SDS=10.0
	IF(DMAX.GT.100.0)SDS=20.0
	IF(DMAX.GT.200.0)SDS=50.0
	IF(DMAX.GT.400.0)SDS=200.0
	IF(DMAX.GT.1000.0)SDS=1000.0
	IF(DMAX.GT.5000.0)SDS=DMAX/5.0
	IF(YREG(IWIN).GT.5.0)THEN
	CALL YAXIS(E(0),'N(E),ST./(RY*CELL)',18,SDS,2,0,1)
	ELSEIF(YREG(IWIN).GT.2.0)THEN
	CALL YAXIS(E(0),'N(E)',4,SDS,2,0,1)
	ELSEIF(YREG(IWIN).GT.1.0)THEN
	CALL YAXIS(E(0),' ',1,SDS,2,0,1)
	ENDIF
C PLOT WINDOW TITLE
	IF(IWINTIT(IWIN).NE.0)THEN
	XSYM=DWINX+0.2
	YSYM=YCOORD+YREG(IWIN)-0.5
	CALL SYMBOL(XSYM,YSYM,0.3,WINTIT(IWIN),40,0.0)
	ENDIF
	YCOORD=YCOORD+YREG(IWIN)
  90    CONTINUE                                !!! over windows
C PLOT FIGURE TITLE
	IF(ITITLE.EQ.1)THEN
	XSYM=DWINX+0.2
	YSYM=YCOORD+0.5
	CALL SYMBOL(XSYM,YSYM,0.5,TITLE,40,0.0)
	ENDIF
C PLOT FERMI LEVEL
	XEF=DWINX+(EF-E(0))/(E(NPNT)-E(0))*XREG 
	YEF=YCOORD
	CALL MOVE(XEF,DWINY,0)
	CALL DASHP(XEF,YEF,0.5)
	XSYM=XEF+0.2 
	YSYM=YEF-0.5
	CALL SYMBOL(XSYM,YSYM,0.3,'EF',2,0.0) 
C END OF PLOT
	CALL ENDPG('END')
	PRINT*,'Normal successfull completion'
	STOP
	END



	SUBROUTINE GETDOS(DOSFILE,NWIN,NPLT,ISOLID,IPEN,DASH,
     &  IWINTIT,WINTIT,ITITLE,TITLE,IPROP,DOSMAX,DM,E,EMIN,EMAX,
     &  EF,NPNT)
************************************************************************
*  Read density of states from DOSFILE and make settings for the plot. *
************************************************************************
C SET PARAMETERS OF ARRAYS AND THEIR MEANING
	PARAMETER (NWINMAX=20)   ! MAX.NUMBER OF WINDOWS
	PARAMETER (NPLTMAX=20)   ! MAX.NUMBER OF PLOTS IN ONE WINDOW
	PARAMETER (LMAXMAX=8)    ! MAX.LMAX
	PARAMETER (NDOSMAX=10000)! MAX.NUMBER OF ENERGY POINTS
	PARAMETER (NSORTMAX=100) ! MAX.NUMBER OF ATOMS OF DIFFERENT TYPE
	PARAMETER (NKAPMAX=5)    ! MAX.NUMBER OF KAPPA
	PARAMETER (NSPINMAX=2)   ! MAX.NUMBER OF SPINS
C DECLARE ARRAYS
	INTEGER ISOLID(NPLTMAX,NWINMAX),IPEN(NPLTMAX,NWINMAX)
     &    ,NPLT(NWINMAX),IWINTIT(NWINMAX),NHSORT(NSORTMAX)
	DIMENSION E(0:NDOSMAX),DOS(0:NDOSMAX),DOSMAX(NWINMAX)
     &    ,SD(4,2:5),DASH(4,NPLTMAX,NWINMAX)
     &    ,TMP(0:LMAXMAX,NSORTMAX,NKAPMAX,NSPINMAX)
     &    ,DSMAX(NPLTMAX,NWINMAX)
	CHARACTER DOSFILE*60,WINTIT(NWINMAX)*40,TITLE*40,PROP*1
C SPECIFY DASHED LINE CHOICES
	DATA (SD(I,2),I=1,4)/0.025,0.075,0.025,0.075/ ! DOTTED LINE
	DATA (SD(I,3),I=1,4)/0.100,0.100,0.100,0.100/ ! DASHED LINE
	DATA (SD(I,4),I=1,4)/0.300,0.100,0.300,0.100/ ! LONG-DASHED
	DATA (SD(I,5),I=1,4)/0.200,0.100,0.025,0.100/ ! DOTTED-DASH
C READ DOSFILE AND CHECK IT
	OPEN(1,FILE=DOSFILE,STATUS='OLD') 
	READ(1,*)EMIN,EMAX,NPNT
	IF(NPNT.GT.NDOSMAX)
     &  STOP'# OF POINTS IS TOO LARGE, INCREASE NDOSMAX'
	READ(1,*,ERR=5)NSORT,LMAX,NKAP,NSPIN,
     &  (NHSORT(ISORT),ISORT=1,NSORT)
	GOTO 10
   5    STOP'THIS VERSION OF PLOTDOS WORKS WITH THE FP-LMTO VERSION 3.16
     &  OR HIGHER'
  10    IF(NSPIN.GT.NSPINMAX)
     &  STOP'NUMBER OF SPINS IS TOO LARGE, INCREASE NSPINMAX'
	IF(NKAP.GT.NKAPMAX)
     &  STOP'NUMBER OF KAPPAS IS TOO LARGW, INCREASE NKAPMAX'
	IF(NSORT.GT.NSORTMAX)
     &  STOP'NUMBER OF SORTS IS TOO LARGE, INCREASE NSORTMAX'
	IF(LMAX.GT.LMAXMAX)STOP'LMAX IS TOO LARGE, INCREASE LMAXMAX'
	READ(1,*)EF,TOSF,DOSF
	DO 20 ISPIN=1,NSPIN
	DO 20 ISORT=1,NSORT
	DO 20 IKAP=1,NKAP
  20    READ(1,*)IK,IS,IP,(TMP(L,ISORT,IKAP,ISPIN),L=0,LMAX)
	DMAX=0.D0
	DO 40 IPNT=0,NPNT
	READ(1,*)E(IPNT),TOSE,DOSE
	DMAX=MAX(DMAX,DOSE)
	DO 30 ISPIN=1,NSPIN
	DO 30 ISORT=1,NSORT
	DO 30 IKAP=1,NKAP
  30    READ(1,*)IS,IK,IP,(TMP(L,ISORT,IKAP,ISPIN),L=0,LMAX)
  40    CONTINUE
	CLOSE(1)
	IF(ABS(E(0)-EMIN).GE.1.D-04)PRINT*,
     &  'EMIN MISMATCHES, CHECK FORMAT OF DOSFILE'
	IF(ABS(E(NPNT)-EMAX).GE.1.D-04)PRINT*,
     &  'EMAX MISMATCHES, CHECK FORMAT OF DOSFILE'
	PRINT50,E(0),E(NPNT),NPNT
	PRINT60,EF,DOSF,DMAX
  50    FORMAT(1X,'Emin=',G14.7,' ; Emax=',G14.7,' ; # of points=',I6)
  60    FORMAT(1X,'EF  =',G14.7,' ; DosF=',G14.7,' ; max. Dos.=',G14.7) 
C OPEN SCRATCH FILE FOR STORING DOS
	NRECL=(NPNT+1)*4
	OPEN(2,STATUS='SCRATCH',FORM='UNFORMATTED',ACCESS='DIRECT',
     &  RECL=NRECL)
	PRINT65
  65    FORMAT(
     &  1X,'File read OK; Enter # of windows you want to create: ',$)
	IREC=0
	READ(5,*)NWIN
	DO 220 IWIN=1,NWIN
	PRINT70,IWIN
  70    FORMAT(1X,'Specify # of plots for window ',I3,' :',$)
	READ(5,*)NPLT(IWIN)
	DO 200 IPLT=1,NPLT(IWIN)
	IREC=IREC+1
	PRINT80,IPLT,IWIN
  80    FORMAT(1X,'Developing plot ',I2,' in window ',I2,' ========>')
	PRINT85
  85    FORMAT(1X,'Enter l+1,isort,ikap,ispin (0 <=> sum over index)')
	READ(5,*)LP,ISORTP,IKAPP,ISPINP
C READ DATA FROM DOSFILE
	OPEN(1,FILE=DOSFILE,STATUS='OLD') 
	READ(1,*)EMIN,EMAX,NPNT
	READ(1,*)NSORT,LMAX,NKAP,NSPIN,(NHSORT(ISORT),ISORT=1,NSORT)
	READ(1,*)EF,TOSF,DOSF
	DO 90 ISPIN=1,NSPIN
	DO 90 ISORT=1,NSORT
	DO 90 IKAP=1,NKAP
  90    READ(1,*)IK,IS,IP,(TMP(L,ISORT,IKAP,ISPIN),L=0,LMAX)
	DSMAX(IPLT,IWIN)=0.0
	DO 150 IPNT=0,NPNT
	READ(1,*)E(IPNT),TOSE,DOSE
	DO 100 ISPIN=1,NSPIN
	DO 100 ISORT=1,NSORT
	DO 100 IKAP=1,NKAP
 100    READ(1,*)IS,IK,IP,(TMP(L,ISORT,IKAP,ISPIN),L=0,LMAX)
	DOS(IPNT)=0.0    
	DO 140 ISPIN=1,NSPIN
	IF(ISPINP.NE.0.AND.ISPINP.NE.ISPIN)GOTO140
	DO 130 ISORT=1,NSORT
	IF(ISORTP.NE.0.AND.ISORTP.NE.ISORT)GOTO130
	IF(ISORTP.NE.0)MTYP=1
	IF(ISORTP.EQ.0)MTYP=NHSORT(ISORT)
	DO 120 IKAP=1,NKAP
	IF(IKAPP.NE.0.AND.IKAPP.NE.IKAP)GOTO120
	DO 110 L=0,LMAX
	IF(LP.NE.0.AND.LP.NE.L+1)GOTO110
	DOS(IPNT)=DOS(IPNT)+TMP(L,ISORT,IKAP,ISPIN)*MTYP
 110    CONTINUE
 120    CONTINUE
 130    CONTINUE
 140    CONTINUE
	DSMAX(IPLT,IWIN)=MAX(DSMAX(IPLT,IWIN),DOS(IPNT))
 150    CONTINUE
	WRITE(2,REC=IREC)(DOS(IPNT),IPNT=1,NPNT)
	CLOSE(1)
	IF(IPLT.EQ.1)THEN
	PRINT*,'Now you must specify how to plot the density of states.'
	PRINT*,'The standard line choices are'
	PRINT*,'    LINE:           CODE:'
	PRINT*,'    full              1   '
	PRINT*,'    dotted            2   '
	PRINT*,'    dashed            3   '
	PRINT*,'    long-dashed       4   '
	PRINT*,'    dotted-dashed     5   '
	PRINT*,'    own choice        6   '
	ENDIF
	PRINT160
 160    FORMAT(1X, 'Enter line code and pen #: ',$)
 170    READ(5,*)ISOLID(IPLT,IWIN),IPEN(IPLT,IWIN)
	IF(ISOLID(IPLT,IWIN).GT.6.OR.ISOLID(IPLT,IWIN).LT.1)THEN
	PRINT*,'PLEASE ENTER LINE CODE AND PEN #'
	GOTO170
	ELSEIF(ISOLID(IPLT,IWIN).EQ.6)THEN
	PRINT180,'Enter your own lenghts of dashes (4 digits) in sm: '
 180    FORMAT(1X,A)
	READ(5,*)DASH(1,IPLT,IWIN),DASH(2,IPLT,IWIN),
     &  DASH(3,IPLT,IWIN),DASH(4,IPLT,IWIN)
	ELSEIF(ISOLID(IPLT,IWIN).GT.1.AND.ISOLID(IPLT,IWIN).LT.6)THEN
	DO 190 ID=1,4
	DASH(ID,IPLT,IWIN)=SD(ID,ISOLID(IPLT,IWIN))
 190    CONTINUE
	ENDIF
 200    CONTINUE                              !!! over plots
	PRINT*,'Type window TITLE by capital letters, (enter if none)'
	READ(5,210)WINTIT(IWIN)
	IWINTIT(IWIN)=1
	IF(WINTIT(IWIN).EQ.' ')IWINTIT(IWIN)=0
 210    FORMAT(A40)
 220    CONTINUE                                 !!! over windows 
C END OF PROCESSING DATA
	PRINT*,'Type FIGURE TITLE by capital letters, (enter if none)'
	READ(5,210)TITLE
	ITITLE=1
	IF(TITLE.EQ.' ')ITITLE=0
C FIND MAXUMAL DOS AT THE FIGURE
	DM=0.0
	DO 240 IWIN=1,NWIN
	DOSMAX(IWIN)=0.0
	DO 230 IPLT=1,NPLT(IWIN)
	DOSMAX(IWIN)=MAX(DOSMAX(IWIN),DSMAX(IPLT,IWIN))
 230    CONTINUE
	DM=MAX(DM,DOSMAX(IWIN))
 240    CONTINUE
	DO 260 IWIN=1,NWIN
	PRINT250,IWIN,(DSMAX(IPLT,IWIN),IPLT=1,NPLT(IWIN))
 250    FORMAT(1X,'Max.dos at window ',I2,' = ',20(1X,G10.3))
 260    CONTINUE
	PRINT270,DM
 270    FORMAT(1X,'Maximal d.o.s. found at whole graph=',G14.7)
	PRINT280
 280    FORMAT(1X,'Enter limit: ',$)
	READ(5,*)DM
	PRINT290
 290    FORMAT(1X,'Do you wish proportional/fixed scaling [p/f] ? ',$)
 300    READ(5,310)PROP
 310    FORMAT(A1) 
	IF(PROP.EQ.'P'.OR.PROP.EQ.'p')IPROP=1
	IF(PROP.EQ.'F'.OR.PROP.EQ.'f')IPROP=0
	IF(PROP.NE.'F'.AND.PROP.NE.'f'.AND.
     &     PROP.NE.'P'.AND.PROP.NE.'p')THEN
	PRINT*,'PLEASE ENTER P FOR PROPORTIONAL, F FOR FIXED SCALING'
	GOTO300
	ENDIF 
	DO 320 IWIN=1,NWIN
	IF(DOSMAX(IWIN).GT.DM)DOSMAX(IWIN)=DM
 320    CONTINUE
	RETURN
	END
