	PROGRAM PLOTPS
*****************************************************
*  Translates PLTFILE of SURFER/GRAPHER software    *
*  to POSTSCRIPT form.                              *
*  Written by S. Savrasov, Last revised 29.11.96.   *
*****************************************************
	INTEGER IVALD(2,5000),IVALM(2,2)
	CHARACTER PLTFILE*60,OUTFILE*60,TCOM*2,YN*1,LINE*50000
     &   ,TVAL1*15,TVAL2*15
	LOGICAL EXIST
C  DEFAULT IS PORTRAIT A4 PAPER
	A4X=8.5  !!! inches
	A4Y=11.0 !!! inches
C  ============================
	PRINT1010
	READ(5,1000)PLTFILE
	IF(PLTFILE(1:1).EQ.' ')PLTFILE='plot.plt'
	PRINT1020
	READ(5,1000)OUTFILE
1000	FORMAT(A)
1010    FORMAT(1X,'Enter PLTFILE [default name is plot.plt]? ',$)
1020    FORMAT(1X,'Enter OUTFILE [default name is plot.ps ]? ',$)
C  CHECK EXISTENCE
	IF(OUTFILE(1:1).EQ.' ')CALL GETOUT(OUTFILE,PLTFILE)
	INQUIRE(FILE=OUTFILE,EXIST=EXIST)
	NB=INDEX(OUTFILE,' ')
	IF(EXIST)THEN
	PRINT1030,OUTFILE(:NB-1)
1030    FORMAT(1X,A, ': File  EXISTS!  Overwrite it [y]? ',$)
	READ(5,1000)YN
	IF(YN.EQ.'Y'.OR.YN.EQ.'y'.OR.YN.EQ.' ')THEN
	OPEN(2,FILE=OUTFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(2,STATUS='DELETE')
	ELSE
	STOP
	ENDIF
	ENDIF
C  SHIFT DATA
	PRINT1040
1040	FORMAT(1X,'Do you wish to shift the entire plot [n]? ',$)
	READ(5,1000)YN
	IF(YN.EQ.'y'.OR.YN.EQ.'Y')THEN
	PRINT1041
1041	FORMAT(1X,'Enter the # of inches to shift along X -> ',$)
	READ(5,*)SH1
	PRINT1042
1042	FORMAT(1X,'Enter the # of inches to shift along Y -> ',$)
	READ(5,*)SH2
	ELSE
	SH1=0.D0
	SH2=0.D0
	ENDIF
C  SCALE DATA
	PRINT1051
1051	FORMAT(1X,'Do you wish to scale the entire plot [n]? ',$)
	READ(5,1000)YN
	IF(YN.EQ.'y'.OR.YN.EQ.'Y')THEN
	PRINT1052
1052	FORMAT(1X,'Enter the scale factor for the X axe   -> ',$)
	READ(5,*)SCAL1
	PRINT1053
1053	FORMAT(1X,'Enter the scale factor for the Y axe   -> ',$)
	READ(5,*)SCAL2
	ELSE
	SCAL1=1.D0
	SCAL2=1.D0
	ENDIF
C  PORTRAIT/LANDSCAPE MODES
	PRINT1060
1060	FORMAT(1X,'Default is PORTRAIT,  make LANDSCAPE [n]? ',$)
	READ(5,1000)YN
	ILAND=0
	IF(YN.EQ.'y'.OR.YN.EQ.'Y')ILAND=1
C  OPEN INPUT/OUTPUT FILES
	OPEN(1,FILE=PLTFILE,STATUS='OLD',FORM='FORMATTED')
	OPEN(2,FILE=OUTFILE,STATUS='NEW',FORM='FORMATTED') 
C ===================================
C WRITE POSTSCRIPT CONTROL STATEMENTS 
	WRITE(2,1110)
	WRITE(2,1120)
	WRITE(2,1130)
	WRITE(2,1140)
	WRITE(2,1150)
	WRITE(2,1160)
	WRITE(2,1000)'S'
	WRITE(2,1000)'6 W'
	WRITE(2,1000)'S'
1110	FORMAT('%! PostScript Driver'/
     &         '%  Created 29.11.96 by S. Savrasov')
1120	FORMAT('gsave')
1130	FORMAT('newpath') 
1140	FORMAT('.072 .072 scale')
1150	FORMAT('/gsdict 4 dict def'/
     &         'gsdict begin'/
     &         '/M /moveto load def'/
     &         '/D /lineto load def'/
     &         '/S /stroke load def'/
     &         '/W /setlinewidth load def')
1160	FORMAT('1.415 setmiterlimit')
C ======================================================================
C DO INFINITE LOOPING, READ COMMANDS IN PLTFILE, TRANSLATE TO POSTSCRIPT
	IWRE=0
	IPLT=0      ! lenght # in OUTFILE
	IREC=0      ! record # in PLTFILE
   1	IREC=IREC+1
	READ(1,1000,ERR=10000,END=10000)TCOM
C IF COMMAND IS "SET PEN", READ PEN#
	IF(TCOM.EQ.'SP')THEN
	BACKSPACE(1)
	READ(1,1200)TCOM,IPEN
1200	FORMAT(A2,1X,I2)
	ELSE
C READ PLOT VALUES
	BACKSPACE(1)
	READ(1,1210,ERR=10000,END=10000)TCOM,VAL1,VAL2
	VALD1=(VAL1+SH1)*SCAL1     !!! X-coordinate in inches
	VALD2=(VAL2+SH2)*SCAL2     !!! Y-coordinate in inches
	IF(ILAND.EQ.0)THEN
	VALP1=VALD1
	VALP2=VALD2
	ELSE
	VALP1=A4X-VALD2
	VALP2=VALD1
	ENDIF
1210	FORMAT(A2,1X,F6.3,1X,F6.3)
	ENDIF
C COLLECT DATA
	IF(TCOM.EQ.'PA')THEN
	IPLT=IPLT+1
	IF(IPLT.GT.5000)STOP'RECORD IS TOO LONG'
	IVALD(1,IPLT)=INT(VALP1*1000)
	IVALD(2,IPLT)=INT(VALP2*1000)
	IVALM(1,1)=IVALM(1,2)
	IVALM(2,1)=IVALM(2,2)
C SWITCH WRITTING	
	ELSEIF(TCOM.EQ.'MA')THEN
	IVALM(1,2)=INT(VALP1*1000)
	IVALM(2,2)=INT(VALP2*1000)
	IF(IPLT.EQ.0)IWRE=0
	IF(IPLT.GT.0)IWRE=1
	IF(IPLT.GT.0)NPLT=IPLT
	IF(IPLT.GT.0)IPLT=0
	ENDIF
C WRITE STATEMENT
	IF(IWRE.EQ.1)THEN
	CALL TWR(IVALM(1,1),TVAL1,LT1)
	CALL TWR(IVALM(2,1),TVAL2,LT2)
	LINE=TVAL1(:LT1)//' '//TVAL2(:LT2)//' M '
	LEN=LT1+LT2+4
	DO IPLT=1,NPLT
	CALL TWR(IVALD(1,IPLT),TVAL1,LT1)
	CALL TWR(IVALD(2,IPLT),TVAL2,LT2)
	LINE=LINE(:LEN)//TVAL1(:LT1)//' '//TVAL2(:LT2)//' D '
	LEN=LEN+LT1+LT2+4
	IF(LEN.GT.50000)STOP'LENGHT IS TOO LONG'
	ENDDO
	LINE=LINE(:LEN)//'S'
	WRITE(2,1000)LINE(:LEN+1)
	IWRE=0
	IPLT=0
	ENDIF
	GOTO1
C END OF LOOPING
10000	WRITE(2,1000)'showpage'
	WRITE(2,1000)'end'
	WRITE(2,1000)'grestore'
	CLOSE(2)
	STOP
	END 


	SUBROUTINE GETOUT(OUTFILE,PLTFILE)
*****************************************************
*  Gets output file by adding '.ps' at the end.     *
*****************************************************
	CHARACTER*60 OUTFILE,PLTFILE
	DO I=1,60
	IF(PLTFILE(I:I).EQ.'.')THEN
	DO J=1,I
	OUTFILE(J:J)=PLTFILE(J:J)
	ENDDO 
	OUTFILE(I+1:I+1)='p'
	OUTFILE(I+2:I+2)='s'
	DO J=I+3,60
	OUTFILE(J:J)=' '
	ENDDO
	RETURN
	ENDIF
	ENDDO
	NB=INDEX(PLTFILE,' ')
	OUTFILE=PLTFILE(:NB-1)//'.ps'
	END



	SUBROUTINE TWR(INT,TINT,LEN)
*****************************************************
* Writes integer to Character strings.              *
*****************************************************
	CHARACTER*15 TINT
	TINT='               '
	WRITE(TINT,*)INT
	CALL RMBLANK(TINT,15)
	LEN=INDEX(TINT,' ')-1
	END


        SUBROUTINE RMBLANK(TEXT,LENGHT)
*****************************************************
*  Removes blanck records in the file TEXT.         *
*****************************************************
        CHARACTER TEXT*(*),LBLANCK*1
        LBLANCK=' '
C  REMOVE BLANKS
        NEWL=LENGHT
        DO 40 I=1,LENGHT
        NBLANCK=0
        DO 10 J=I,NEWL
        IF(TEXT(J:J).EQ.LBLANCK)THEN
        NBLANCK=NBLANCK+1
        ELSE
        GOTO20
        ENDIF
  10    CONTINUE
  20    DO 30 J=I+NBLANCK,NEWL
        TEXT(J-NBLANCK:J-NBLANCK)=TEXT(J:J)
  30    CONTINUE
        NEWL=NEWL-NBLANCK
  40    CONTINUE
        DO 50 I=NEWL+1,LENGHT
        TEXT(I:I)=LBLANCK
  50    CONTINUE
        END


